
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    float g_fBiasFactor;
    float g_fNearClip;
    float g_fFarClip;
};

layout(set = 2, binding = 7, std140) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 3, binding = 11, std140) uniform type_MeshConstants
{
    vec3 g_xPrecisionOffset;
    uint g_bIsBillboard;
    vec3 g_xPrecisionScale;
    uint g_bIsInteractive;
} MeshConstants;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_TEXCOORD0;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec3 in_var_TESSNORMAL;
layout(location = 4) in vec4 in_var_POSITION1;
layout(location = 5) in vec4 in_var_POSITION2;
layout(location = 6) in vec4 in_var_POSITION3;
layout(location = 7) in vec4 in_var_POSITION4;
layout(location = 0) out vec2 out_var_TEXCOORD0;

vec4 _48;

void main()
{
    vec3 _65 = (in_var_POSITION0.xyz * MeshConstants.g_xPrecisionScale) + MeshConstants.g_xPrecisionOffset;
    vec4 _67 = _48;
    _67.x = dot(_65, in_var_POSITION2.xyz);
    vec4 _69 = _67;
    _69.y = dot(_65, in_var_POSITION3.xyz);
    vec4 _71 = _69;
    _71.z = dot(_65, in_var_POSITION4.xyz);
    vec4 _98;
    if (MeshConstants.g_bIsInteractive != 0u)
    {
        vec4 _80 = _48;
        _80.x = in_var_POSITION2.w;
        vec4 _82 = _80;
        _82.y = in_var_POSITION3.w;
        vec4 _84 = _82;
        _84.z = in_var_POSITION4.w;
        vec3 _90 = cross(_84.xyz, _71.xyz);
        vec3 _96 = (((_90 * sqrt(clamp(1.0 - dot(_84.xyz, _84.xyz), 0.0, 1.0))) + cross(_84.xyz, _90)) * (2.0 * in_var_POSITION0.w)) + _71.xyz;
        _98 = vec4(_96.x, _96.y, _96.z, _71.w);
    }
    else
    {
        _98 = _71;
    }
    gl_Position = vec4(_98.xyz + in_var_POSITION1.xyz, 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
    out_var_TEXCOORD0 = in_var_TEXCOORD0.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
}

