#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct StaticMaterial
{
    float m_fMaterialIndex;
    vec3 m_xAlbedoTint;
    vec4 m_xParallaxUVScaleAndSpeed;
    float m_fRefractivity;
    float m_fParallaxScale;
    float m_fParallaxBias;
    float m_fAlbedoDetailUVScale;
    float m_fAlbedoDetailValueScale;
    float m_fNormalDetailUVScale;
    float m_fNormalDetailValueScale;
    float m_fMaterialModel;
    float m_fSlopeShaderUVScale;
    float m_fSlopeShaderStrength;
    float m_fSlopeShaderThreshold;
    float m_fSlopeShaderPower;
    float m_fSlopeShaderThresFactor;
    vec3 m_xSlopeShaderNormal;
    vec3 m_xSlopeShaderForward;
    float m_fPad;
    float m_fInvHeightmapBlendSoftness;
    float m_fDecalNormalThresholdA;
    float m_fDecalNormalThresholdB;
    float m_fFoliageCosClippingAngle;
    float m_fWindResponsiveness;
    uint m_bRefractionBlendBackground;
    uint m_bIsDecal;
    uint m_bIsFoliage;
    uint m_bReflectBackfaceNormalsWithView;
    uint m_bUseBinarySearchForParallax;
    uint m_bUseAlbedo;
    uint m_bUseNormalMap;
    uint m_bUseMetalMap;
    uint m_bUseTransparencyMap;
    uint m_bUseSelfIlluminationMap;
    uint m_bUseParallaxMap;
    uint m_bUseEnvironmentMap;
    uint m_bUseAlbedoDetailMap;
    uint m_bUseNormalDetailMap;
    uint m_bUseSelfIlluminationGraph;
    uint m_bUseRefraction;
    uint m_bUseTransparencyGraph;
    uint m_bUseSlopeShader;
    uint m_bUseHairFlowMap;
    uint m_bUseHairNoiseMap;
    uint m_bHasParallaxMap;
    uint m_bUseSlopeShaderAlbedoMap1;
    uint m_bUseSlopeShaderNormalMap1;
    uint m_bUseSlopeShaderTransparencyMap1;
    uint m_bUseDamageThresholdMap;
    uint m_bUseFaceWrinkles;
    uint m_bUseRippleMap;
    uint m_uAlbedoMap;
    uint m_uAlbedoDetailMap;
    uint m_uNormalMap;
    uint m_uNormalDetailMap;
    uint m_uMetalMap;
    uint m_uTransparencyMap;
    uint m_uSelfIlluminationMap;
    uint m_uParallaxMap;
    uint m_uHairFlowMap;
    uint m_uHairNoiseMap;
    uint m_uSlopeShaderAlbedoMap;
    uint m_uSlopeShaderNormalMap;
    uint m_uSlopeShaderTransparencyMap;
    uint m_uDamageThresholdMap;
    uint m_uWrinkleMask_Compressed;
    uint m_uWrinkleMask_Stretched;
    uint m_uWrinkleMap_Compressed;
    uint m_uWrinkleMap_Stretched;
    uint m_uRippleMap;
    uint m_bIsTransmissive;
    uint m_bIsDeformable;
    float m_fDeformableHeight;
    uint m_uDeformableDetailAlbedoMap;
    uint m_uDeformableDetailNormalMap;
    float m_fDeformableDetailMapUVScale;
    float m_fDeformableDetailBlendPower;
    float m_fPorosity;
    uint m_uStructuredBufferIndex;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 4, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 4, binding = 48, scalar) readonly buffer type_StructuredBuffer_StaticMaterial
{
    StaticMaterial _m0[];
} g_axMaterials;

layout(set = 3, binding = 1, scalar) uniform type_Material1Constants
{
    StaticMaterial g_xStaticMaterial1;
} Material1Constants;

layout(set = 3, binding = 2, scalar) uniform type_Material2Constants
{
    StaticMaterial g_xStaticMaterial2;
} Material2Constants;

layout(set = 1, binding = 3, std140) uniform type_DynamicMaterialConstants
{
    vec3 g_xSelfIlluminationParameters;
    float g_fFogScale;
    vec4 g_xUVScaleOffset;
} DynamicMaterialConstants;

layout(set = 4, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 0, binding = 5) uniform sampler g_xTrilinearClamp;
layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 5, binding = 0) 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
uniform texture2D g_xTextureArray[];
layout(set = 4, binding = 88) uniform TEXTURE_2D g_xMaterialsTexture;
layout(set = 4, binding = 98) uniform TEXTURE_2D g_xRainReachabilityMask;

layout(location = 0) in vec4 in_var_NORMAL0;
layout(location = 1) in vec3 in_var_TANGENT0;
layout(location = 2) in vec3 in_var_BINORMAL0;
layout(location = 3) in vec4 in_var_TEXCOORD0;
layout(location = 4) in vec4 in_var_TEXCOORD1;
layout(location = 5) flat in uint in_var_TEXCOORD2;
layout(location = 0) out vec4 out_var_SV_Target0;
layout(location = 1) out vec4 out_var_SV_Target1;
layout(location = 2) out vec4 out_var_SV_Target2;
layout(location = 3) out vec4 out_var_SV_Target3;

vec3 _236;
vec4 _237;
vec4 _238;

void main()
{
    vec3 _252 = normalize(in_var_NORMAL0.xyz);
    vec3 _254 = normalize(in_var_TEXCOORD1.xyz);
    vec3 _256 = normalize(in_var_BINORMAL0);
    mat3 _257 = mat3(normalize(in_var_TANGENT0), _256, _252);
    vec4 _268 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
    vec4 _276 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uDamageThresholdMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
    float _284 = 1.0 - (smoothstep(0.0, 0.100000001490116119384765625, ((g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseDamageThresholdMap != 0u) ? _276.x : 1.0) - ((in_var_NORMAL0.w - 0.100000001490116119384765625) * 1.10000002384185791015625)) * ((g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u) ? _268.w : 1.0));
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u)
        {
            if ((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialModel == 4.0) ? (-1.0) : 0.0).w - 0.0500000007450580596923828125) < 0.0)
            {
                discard;
            }
            break;
        }
        else
        {
            break;
        }
    } while(false);
    vec3 _399;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
        {
            vec4 _316 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
            vec2 _319 = (_316.xy * 2.0) - vec2(1.0);
            vec3 _341;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
            {
                vec2 _339 = _319.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                _341 = vec3(_339.x, _339.y, _236.z);
            }
            else
            {
                _341 = vec3(_319.x, _319.y, _236.z);
            }
            vec3 _344 = _341;
            _344.y = -_341.y;
            vec3 _350 = _344;
            _350.z = sqrt(clamp(1.0 - dot(_344.xy, _344.xy), 0.0, 1.0));
            vec3 _351 = _257 * _350;
            vec3 _397;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
            {
                vec4 _359 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
                vec2 _362 = (_359.xy * 2.0) - vec2(1.0);
                vec3 _384;
                if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
                {
                    vec2 _382 = _362.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                    _384 = vec3(_382.x, _382.y, _236.z);
                }
                else
                {
                    _384 = vec3(_362.x, _362.y, _236.z);
                }
                vec3 _387 = _384;
                _387.y = -_384.y;
                vec3 _393 = _387;
                _393.z = sqrt(clamp(1.0 - dot(_387.xy, _387.xy), 0.0, 1.0));
                _397 = mix(_257 * _393, _351, vec3(_284));
            }
            else
            {
                _397 = _351;
            }
            _399 = normalize(_397);
            break;
        }
        else
        {
            _399 = _252;
            break;
        }
    } while(false);
    uint _408 = in_var_TEXCOORD2 + 3u;
    vec4 _415 = vec4(_399, 1.0);
    vec3 _417 = _236;
    _417.x = dot(_415, g_xInstanceTexture._m0[in_var_TEXCOORD2]);
    vec3 _419 = _417;
    _419.y = dot(_415, g_xInstanceTexture._m0[in_var_TEXCOORD2 + 1u]);
    vec3 _421 = _419;
    _421.z = dot(_415, g_xInstanceTexture._m0[in_var_TEXCOORD2 + 2u]);
    vec3 _423 = max(_421, vec3(0.0)) * 2.0;
    vec3 _426 = FrameConstants.g_xCamPos - in_var_TEXCOORD1.xyz;
    vec4 _522;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
    {
        vec4 _439 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
        vec4 _468;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedoDetailMap != 0u)
        {
            vec3 _451 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
            vec3 _452 = _439.xyz;
            vec3 _466 = clamp(mix(_452, mix((_451 * 2.0) * _452, vec3(1.0) - (((vec3(1.0) - _451) * 2.0) * (vec3(1.0) - _452)), step(vec3(0.5), _452)), vec3(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
            _468 = vec4(_466.x, _466.y, _466.z, _439.w);
        }
        else
        {
            _468 = _439;
        }
        vec3 _472 = _468.xyz * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint;
        vec4 _473 = vec4(_472.x, _472.y, _472.z, _468.w);
        vec4 _518;
        if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
        {
            vec4 _481 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uAlbedoMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
            vec4 _510;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseAlbedoDetailMap != 0u)
            {
                vec3 _493 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
                vec3 _494 = _481.xyz;
                vec3 _508 = clamp(mix(_494, mix((_493 * 2.0) * _494, vec3(1.0) - (((vec3(1.0) - _493) * 2.0) * (vec3(1.0) - _494)), step(vec3(0.5), _494)), vec3(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
                _510 = vec4(_508.x, _508.y, _508.z, _481.w);
            }
            else
            {
                _510 = _481;
            }
            vec3 _514 = _510.xyz * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xAlbedoTint;
            _518 = mix(vec4(_514.x, _514.y, _514.z, _510.w), _473, vec4(_284));
        }
        else
        {
            _518 = _473;
        }
        vec4 _521 = vec4(_518.x, _518.y, _518.z, _237.w);
        _521.w = _518.w;
        _522 = _521;
    }
    else
    {
        vec4 _436 = vec4(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.x, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.y, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.z, _237.w);
        _436.w = 1.0;
        _522 = _436;
    }
    vec4 _609;
    vec3 _610;
    vec3 _611;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShader != 0u)
    {
        vec3 _533 = cross(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderNormal, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderForward);
        vec2 _539 = vec2(dot(_533, _426), dot(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderForward, _426)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderUVScale;
        float _554 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderStrength * pow(clamp(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderThresFactor * (dot(_399, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderNormal) - g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderThreshold), 0.0, 1.0), g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderPower);
        float _565;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShaderTransparencyMap1 != 0u)
        {
            _565 = _554 * 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSlopeShaderTransparencyMap)], g_xFilteredWrap)), _539, FrameConstants.g_fGlobalSamplerBias).w;
        }
        else
        {
            _565 = _554;
        }
        vec4 _581;
        vec3 _582;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShaderAlbedoMap1 != 0u)
        {
            vec4 _573 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSlopeShaderAlbedoMap)], g_xFilteredWrap)), _539, FrameConstants.g_fGlobalSamplerBias);
            vec4 _580 = _238;
            _580.w = mix(_522.w, _573.w, _565);
            _581 = _580;
            _582 = mix(_522.xyz, _573.xyz, vec3(_565));
        }
        else
        {
            _581 = _522;
            _582 = _522.xyz;
        }
        vec3 _608;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShaderNormalMap1 != 0u)
        {
            vec2 _593 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSlopeShaderNormalMap)], g_xFilteredWrap)), _539, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0);
            vec2 _595 = _593.xy;
            vec3 _600 = vec3(_593.x, _593.y, _236.z);
            _600.z = sqrt(clamp(1.0 - dot(_595, _595), 0.0, 1.0));
            _608 = normalize(mix(_399, mat3(_533, -g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderForward, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderNormal) * _600, vec3(_565)));
        }
        else
        {
            _608 = _399;
        }
        _609 = _581;
        _610 = _608;
        _611 = _582;
    }
    else
    {
        _609 = _522;
        _610 = _399;
        _611 = _522.xyz;
    }
    float _616 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialModel * 0.0039215688593685626983642578125;
    vec4 _728;
    if (_616 == 0.0)
    {
        float _724;
        do
        {
            float _712;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _712 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _712 = 0.0;
            }
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _724 = mix(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w, _712, _284);
                break;
            }
            else
            {
                _724 = _712;
                break;
            }
        } while(false);
        vec3 _726 = _423 * (1.0 - _724);
        _728 = vec4(_726.x, _726.y, _726.z, _237.w);
    }
    else
    {
        vec4 _700;
        if (_616 == 0.0039215688593685626983642578125)
        {
            float _685;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _685 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _685 = 1.0;
            }
            vec3 _698 = _423 + (_611.xyz * (_685 * clamp((clamp(dot(g_xInstanceTexture._m0[_408].xyz, -_610), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(g_xInstanceTexture._m0[_408].xyz, -_254), 0.0, 1.0), 7.0), 0.0, 1.0)));
            _700 = vec4(_698.x, _698.y, _698.z, _237.w);
        }
        else
        {
            vec4 _675;
            if (_616 == 0.01960784383118152618408203125)
            {
                float _653;
                do
                {
                    float _641;
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _641 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
                    }
                    else
                    {
                        _641 = 0.5;
                    }
                    if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _653 = mix(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w, _641, _284);
                        break;
                    }
                    else
                    {
                        _653 = _641;
                        break;
                    }
                } while(false);
                vec3 _673 = mix(_423 * 1.0, _423 + ((_611.xyz * clamp((clamp(dot(g_xInstanceTexture._m0[_408].xyz, -_610), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(g_xInstanceTexture._m0[_408].xyz, -_254), 0.0, 1.0), 7.0), 0.0, 1.0)) * ((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsTransmissive != 0u) ? 0.5 : 0.0)), vec3(_653));
                _675 = vec4(_673.x, _673.y, _673.z, _237.w);
            }
            else
            {
                _675 = vec4(_423.x, _423.y, _423.z, _237.w);
            }
            _700 = _675;
        }
        _728 = _700;
    }
    float _750;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSelfIlluminationGraph != 0u)
        {
            _750 = (TEXTURE_LOD(SAMPLER_2D(g_xMaterialsTexture, g_xTrilinearClamp), vec2((min(1.0, dot(_610, _254)) * 0.498046875) + 0.5, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialIndex), 0.0) * 2.0).y;
            break;
        }
        else
        {
            _750 = 1.0;
            break;
        }
    } while(false);
    vec3 _774;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSelfIlluminationMap != 0u)
    {
        vec4 _760 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSelfIlluminationMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
        float _761 = _760.w;
        float _772;
        if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseSelfIlluminationMap != 0u)
        {
            _772 = mix(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uSelfIlluminationMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w, _761, _284);
        }
        else
        {
            _772 = _761;
        }
        _774 = DynamicMaterialConstants.g_xSelfIlluminationParameters * _772;
    }
    else
    {
        _774 = DynamicMaterialConstants.g_xSelfIlluminationParameters;
    }
    vec3 _777 = _728.xyz + (_774 * _750);
    float _782 = clamp(dot(_254, normalize(_254 + g_xInstanceTexture._m0[_408].xyz)), 0.0, 1.0);
    vec4 _790 = vec4(_777.x, _777.y, _777.z, _728.w);
    _790.w = (dot(_423, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375)) * 4.0) * (1.0 / ((3.0 * (_782 * _782)) + 1.0));
    float _803;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseHairNoiseMap != 0u)
        {
            _803 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uHairNoiseMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
            break;
        }
        else
        {
            _803 = 0.5;
            break;
        }
    } while(false);
    bool _804 = _803 < 0.0039215688593685626983642578125;
    vec3 _878;
    if (_804)
    {
        _878 = g_xInstanceTexture._m0[_408].xyz;
    }
    else
    {
        vec3 _877;
        do
        {
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseHairFlowMap != 0u)
            {
                vec2 _821 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uHairFlowMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0);
                vec3 _825 = vec3(_821.x, _821.y, _236.z);
                _825.y = -_821.y;
                vec3 _826 = _825;
                _826.z = 0.0;
                vec4 _834 = vec4(cross(_252, _610), dot(_252, _610) + 1.0);
                float _835 = length(_834);
                vec4 _840 = mix(_834, _834 / vec4(_835), bvec4(_835 > 0.0));
                vec3 _842 = _840.xyz * 2.0;
                vec3 _844 = _842 * _840.w;
                vec3 _846 = _842 * _840.x;
                vec3 _849 = _840.yyz * _842.yzz;
                float _850 = _849.x;
                float _851 = _849.z;
                float _854 = _846.y;
                float _855 = _844.z;
                float _857 = _846.z;
                float _858 = _844.y;
                float _861 = _846.x;
                float _864 = _849.y;
                float _865 = _844.x;
                _877 = normalize(mat3(vec3(1.0 - (_850 + _851), _854 + _855, _857 - _858), vec3(_854 - _855, 1.0 - (_861 + _851), _864 + _865), vec3(_857 + _858, _864 - _865, 1.0 - (_861 + _850))) * (_257 * _826));
                break;
            }
            else
            {
                _877 = _256;
                break;
            }
        } while(false);
        _878 = _877;
    }
    uint _883 = floatBitsToUint(g_xInstanceTexture._m0[_408].w);
    uint _884 = _883 >> 24u;
    vec4 _907;
    vec3 _908;
    if ((_884 & 1u) != 0u)
    {
        vec3 _892 = _236;
        _892.x = float((_883 & 16711680u) >> 16u);
        vec3 _896 = _892;
        _896.y = float((_883 & 65280u) >> 8u);
        vec3 _899 = _896;
        _899.z = float(_883 & 255u);
        vec3 _900 = _899 * vec3(0.0039215688593685626983642578125);
        vec3 _905 = _900 * dot(_790.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375));
        _907 = vec4(_905.x, _905.y, _905.z, _790.w);
        _908 = _900 * dot(_611.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375));
    }
    else
    {
        _907 = _790;
        _908 = _611.xyz;
    }
    vec4 _917;
    if ((_884 & 2u) != 0u)
    {
        vec4 _916 = _907;
        _916.w = min(-_907.w, -9.9999997473787516355514526367188e-05);
        _917 = _916;
    }
    else
    {
        _917 = _907;
    }
    vec3 _969;
    float _970;
    if (FrameConstants.g_fRainfallIntensity > 0.0)
    {
        float _927 = mix(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fPorosity, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fPorosity, _284);
        uint _928 = in_var_TEXCOORD2 + 4u;
        float _949;
        if (g_xInstanceTexture._m0[_928].x >= 0.0)
        {
            _949 = g_xInstanceTexture._m0[_928].x * FrameConstants.g_fRainBaseWetness;
        }
        else
        {
            _949 = SAMPLE_TEXTURE1(SAMPLER_2D(g_xRainReachabilityMask, g_xBilinearClamp), gl_FragCoord.xy / vec2(FrameConstants.g_xScreenDimensions.xy), FrameConstants.g_fGlobalSamplerBias).x;
        }
        float _951 = _949 * (1.0 - _927);
        float _952 = _949 * _927;
        float _961 = mix(1.0, 0.0500000007450580596923828125, _951);
        _969 = mix(_908, clamp(mix(_908, vec3(dot(_908, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375))), vec3(-0.60000002384185791015625)), vec3(0.0), vec3(1.0)) * mix(1.0, 0.4000000059604644775390625, _952), vec3(_952));
        _970 = mix(mix(_609.w, min(_609.w, _961 * _961), _951), _609.w, clamp((in_var_TEXCOORD1.w - 50.0) * 0.00999999977648258209228515625, 0.0, 1.0));
    }
    else
    {
        _969 = _908;
        _970 = _609.w;
    }
    vec4 _988 = vec4(_969.x, _969.y, _969.z, _237.w);
    _988.w = _804 ? 0.007843137718737125396728515625 : _616;
    out_var_SV_Target0 = _917;
    out_var_SV_Target1 = _988;
    out_var_SV_Target2 = vec4((_610 * 0.5) + vec3(0.5), (_804 ? false : true) ? ((_878.z > 0.0) ? 0.5 : 0.0) : 1.0);
    out_var_SV_Target3 = vec4(_803, _970, (_878.xy * 0.5) + vec2(0.5));
}

