#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct StaticMaterial
{
    float m_fMaterialIndex;
    vec3 m_xAlbedoTint;
    vec4 m_xParallaxUVScaleAndSpeed;
    float m_fRefractivity;
    float m_fParallaxScale;
    float m_fParallaxBias;
    float m_fAlbedoDetailUVScale;
    float m_fAlbedoDetailValueScale;
    float m_fNormalDetailUVScale;
    float m_fNormalDetailValueScale;
    float m_fMaterialModel;
    float m_fSlopeShaderUVScale;
    float m_fSlopeShaderStrength;
    float m_fSlopeShaderThreshold;
    float m_fSlopeShaderPower;
    float m_fSlopeShaderThresFactor;
    vec3 m_xSlopeShaderNormal;
    vec3 m_xSlopeShaderForward;
    float m_fPad;
    float m_fInvHeightmapBlendSoftness;
    float m_fDecalNormalThresholdA;
    float m_fDecalNormalThresholdB;
    float m_fFoliageCosClippingAngle;
    float m_fWindResponsiveness;
    uint m_bRefractionBlendBackground;
    uint m_bIsDecal;
    uint m_bIsFoliage;
    uint m_bReflectBackfaceNormalsWithView;
    uint m_bUseBinarySearchForParallax;
    uint m_bUseAlbedo;
    uint m_bUseNormalMap;
    uint m_bUseMetalMap;
    uint m_bUseTransparencyMap;
    uint m_bUseSelfIlluminationMap;
    uint m_bUseParallaxMap;
    uint m_bUseEnvironmentMap;
    uint m_bUseAlbedoDetailMap;
    uint m_bUseNormalDetailMap;
    uint m_bUseSelfIlluminationGraph;
    uint m_bUseRefraction;
    uint m_bUseTransparencyGraph;
    uint m_bUseSlopeShader;
    uint m_bUseHairFlowMap;
    uint m_bUseHairNoiseMap;
    uint m_bHasParallaxMap;
    uint m_bUseSlopeShaderAlbedoMap1;
    uint m_bUseSlopeShaderNormalMap1;
    uint m_bUseSlopeShaderTransparencyMap1;
    uint m_bUseDamageThresholdMap;
    uint m_bUseFaceWrinkles;
    uint m_bUseRippleMap;
    uint m_uAlbedoMap;
    uint m_uAlbedoDetailMap;
    uint m_uNormalMap;
    uint m_uNormalDetailMap;
    uint m_uMetalMap;
    uint m_uTransparencyMap;
    uint m_uSelfIlluminationMap;
    uint m_uParallaxMap;
    uint m_uHairFlowMap;
    uint m_uHairNoiseMap;
    uint m_uSlopeShaderAlbedoMap;
    uint m_uSlopeShaderNormalMap;
    uint m_uSlopeShaderTransparencyMap;
    uint m_uDamageThresholdMap;
    uint m_uWrinkleMask_Compressed;
    uint m_uWrinkleMask_Stretched;
    uint m_uWrinkleMap_Compressed;
    uint m_uWrinkleMap_Stretched;
    uint m_uRippleMap;
    uint m_bIsTransmissive;
    uint m_bIsDeformable;
    float m_fDeformableHeight;
    uint m_uDeformableDetailAlbedoMap;
    uint m_uDeformableDetailNormalMap;
    float m_fDeformableDetailMapUVScale;
    float m_fDeformableDetailBlendPower;
    float m_fPorosity;
    uint m_uStructuredBufferIndex;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 4, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 4, binding = 48, scalar) readonly buffer type_StructuredBuffer_StaticMaterial
{
    StaticMaterial _m0[];
} g_axMaterials;

layout(set = 3, binding = 1, scalar) uniform type_Material1Constants
{
    StaticMaterial g_xStaticMaterial1;
} Material1Constants;

layout(set = 3, binding = 2, scalar) uniform type_Material2Constants
{
    StaticMaterial g_xStaticMaterial2;
} Material2Constants;

layout(set = 4, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 5, binding = 0) 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
uniform texture2D g_xTextureArray[];
layout(set = 4, binding = 98) uniform TEXTURE_2D g_xRainReachabilityMask;

layout(location = 0) in vec4 in_var_NORMAL0;
layout(location = 1) in vec3 in_var_TANGENT0;
layout(location = 2) in vec3 in_var_BINORMAL0;
layout(location = 3) in vec4 in_var_TEXCOORD0;
layout(location = 4) in vec4 in_var_TEXCOORD1;
layout(location = 5) flat in uint in_var_TEXCOORD2;
layout(location = 0) out vec4 out_var_SV_Target0;
layout(location = 1) out vec4 out_var_SV_Target1;
layout(location = 2) out vec4 out_var_SV_Target2;
layout(location = 3) out vec4 out_var_SV_Target3;

vec3 _196;
vec4 _197;
vec4 _198;

void main()
{
    vec3 _212 = normalize(in_var_NORMAL0.xyz);
    mat3 _217 = mat3(normalize(in_var_TANGENT0), normalize(in_var_BINORMAL0), _212);
    vec4 _383;
    if ((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) || (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u))
    {
        vec3 _229 = normalize(in_var_TEXCOORD1.xyz) * _217;
        vec4 _382;
        if ((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) || (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u))
        {
            vec4 _381;
            if (((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) && (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseBinarySearchForParallax != 0u)) || ((g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u) && (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseBinarySearchForParallax != 0u)))
            {
                vec3 _326 = normalize((-_229) / vec3(_229.z));
                _326.z = 1.0;
                vec3 _328;
                vec4 _333;
                _328 = _326;
                _333 = in_var_TEXCOORD0.xyxy;
                vec3 _329;
                float _332;
                vec4 _334;
                float _331 = 0.0;
                int _335 = 0;
                for (; _335 < 12; _328 = _329, _331 = _332, _333 = _334, _335++)
                {
                    float _368;
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
                    {
                        _368 = ((1.0 - 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (_333.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxBias;
                    }
                    else
                    {
                        _368 = 0.0;
                    }
                    _329 = _328 * 0.5;
                    if (_331 < _368)
                    {
                        _332 = _331 + _329.z;
                        _334 = _333 + _329.xyxy;
                    }
                    else
                    {
                        _332 = _331 - _329.z;
                        _334 = _333 - _329.xyxy;
                    }
                }
                _381 = _333;
            }
            else
            {
                float _280;
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
                {
                    _280 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), (in_var_TEXCOORD0.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxBias;
                }
                else
                {
                    _280 = 0.0;
                }
                vec2 _282 = _229.xy * _280;
                float _312;
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseParallaxMap != 0u)
                {
                    _312 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uParallaxMap)], g_xFilteredWrap)), ((in_var_TEXCOORD0.xyxy + _282.xyxy).xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxScale) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fParallaxBias;
                }
                else
                {
                    _312 = 0.0;
                }
                _381 = in_var_TEXCOORD0.xyxy + (_282 * clamp((-_280) / (_312 - (2.0 * _280)), 0.0, 1.0)).xyxy;
            }
            _382 = _381;
        }
        else
        {
            _382 = in_var_TEXCOORD0.xyxy;
        }
        _383 = _382;
    }
    else
    {
        _383 = in_var_TEXCOORD0.xyxy;
    }
    float _406;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u)
        {
            vec4 _400 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), _383.xy, (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialModel == 4.0) ? (-1.0) : 0.0);
            float _401 = _400.w;
            if ((_401 - 0.0500000007450580596923828125) < 0.0)
            {
                discard;
            }
            _406 = _401;
            break;
        }
        else
        {
            _406 = 1.0;
            break;
        }
    } while(false);
    vec3 _458;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
        {
            vec4 _421 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), _383.xy, FrameConstants.g_fGlobalSamplerBias);
            vec2 _424 = (_421.xy * 2.0) - vec2(1.0);
            vec3 _446;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
            {
                vec2 _444 = _424.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), _383.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                _446 = vec3(_444.x, _444.y, _196.z);
            }
            else
            {
                _446 = vec3(_424.x, _424.y, _196.z);
            }
            vec3 _449 = _446;
            _449.y = -_446.y;
            vec3 _455 = _449;
            _455.z = sqrt(clamp(1.0 - dot(_449.xy, _449.xy), 0.0, 1.0));
            _458 = normalize(_217 * _455);
            break;
        }
        else
        {
            _458 = _212;
            break;
        }
    } while(false);
    vec3 _461 = FrameConstants.g_xCamPos - in_var_TEXCOORD1.xyz;
    vec4 _515;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
    {
        vec4 _478 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoMap)], g_xFilteredWrap)), _383.xy, FrameConstants.g_fGlobalSamplerBias);
        vec4 _507;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedoDetailMap != 0u)
        {
            vec3 _490 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), _383.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
            vec3 _491 = _478.xyz;
            vec3 _505 = clamp(mix(_491, mix((_490 * 2.0) * _491, vec3(1.0) - (((vec3(1.0) - _490) * 2.0) * (vec3(1.0) - _491)), step(vec3(0.5), _491)), vec3(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
            _507 = vec4(_505.x, _505.y, _505.z, _478.w);
        }
        else
        {
            _507 = _478;
        }
        vec3 _511 = _507.xyz * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint;
        vec4 _514 = vec4(_511.x, _511.y, _511.z, _197.w);
        _514.w = _507.w;
        _515 = _514;
    }
    else
    {
        vec4 _471 = vec4(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.x, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.y, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.z, _197.w);
        _471.w = 1.0;
        _515 = _471;
    }
    vec4 _611;
    vec3 _612;
    vec3 _613;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShader != 0u)
    {
        vec3 _526 = cross(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderNormal, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderForward);
        vec2 _532 = vec2(dot(_526, _461), dot(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderForward, _461)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderUVScale;
        float _547 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderStrength * pow(clamp(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderThresFactor * (dot(_458, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderNormal) - g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderThreshold), 0.0, 1.0), g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fSlopeShaderPower);
        float _561;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShaderTransparencyMap1 != 0u)
        {
            _561 = _547 * 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSlopeShaderTransparencyMap)], g_xFilteredWrap)), _532, FrameConstants.g_fGlobalSamplerBias).w;
        }
        else
        {
            _561 = _547;
        }
        vec4 _580;
        vec3 _581;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShaderAlbedoMap1 != 0u)
        {
            vec4 _572 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSlopeShaderAlbedoMap)], g_xFilteredWrap)), _532, FrameConstants.g_fGlobalSamplerBias);
            vec4 _579 = _198;
            _579.w = mix(_515.w, _572.w, _561);
            _580 = _579;
            _581 = mix(_515.xyz, _572.xyz, vec3(_561));
        }
        else
        {
            _580 = _515;
            _581 = _515.xyz;
        }
        vec3 _610;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSlopeShaderNormalMap1 != 0u)
        {
            vec2 _595 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSlopeShaderNormalMap)], g_xFilteredWrap)), _532, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0);
            vec2 _597 = _595.xy;
            vec3 _602 = vec3(_595.x, _595.y, _196.z);
            _602.z = sqrt(clamp(1.0 - dot(_597, _597), 0.0, 1.0));
            _610 = normalize(mix(_458, mat3(_526, -g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderForward, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xSlopeShaderNormal) * _602, vec3(_561)));
        }
        else
        {
            _610 = _458;
        }
        _611 = _580;
        _612 = _610;
        _613 = _581;
    }
    else
    {
        _611 = _515;
        _612 = _458;
        _613 = _515.xyz;
    }
    float _618 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialModel * 0.0039215688593685626983642578125;
    float _722;
    if (_618 == 0.0)
    {
        float _715;
        do
        {
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _715 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _383.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _715 = 0.0;
            }
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                break;
            }
            else
            {
                break;
            }
        } while(false);
        _722 = _715;
    }
    else
    {
        float _699;
        if (_618 == 0.0039215688593685626983642578125)
        {
            float _698;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _698 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _383.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _698 = 1.0;
            }
            _699 = _698;
        }
        else
        {
            float _684;
            if (_618 == 0.01960784383118152618408203125)
            {
                float _668;
                do
                {
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _668 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _383.xy, FrameConstants.g_fGlobalSamplerBias).w;
                    }
                    else
                    {
                        _668 = 0.5;
                    }
                    if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        break;
                    }
                    else
                    {
                        break;
                    }
                } while(false);
                float _680 = clamp(_668, 0.0, 1.0) * 0.4980392158031463623046875;
                _684 = (((g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsTransmissive != 0u) ? 0.5 : 0.0) > 0.0) ? (_680 + 0.501960813999176025390625) : _680;
            }
            else
            {
                float _646;
                do
                {
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _646 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _383.xy, FrameConstants.g_fGlobalSamplerBias).w;
                    }
                    else
                    {
                        _646 = 0.0;
                    }
                    if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        break;
                    }
                    else
                    {
                        break;
                    }
                } while(false);
                _684 = _646;
            }
            _699 = _684;
        }
        _722 = _699;
    }
    uint _726 = floatBitsToUint(g_xInstanceTexture._m0[in_var_TEXCOORD2 + 3u].w);
    vec3 _746;
    if (((_726 >> 24u) & 1u) != 0u)
    {
        vec3 _735 = _196;
        _735.x = float((_726 & 16711680u) >> 16u);
        vec3 _739 = _735;
        _739.y = float((_726 & 65280u) >> 8u);
        vec3 _742 = _739;
        _742.z = float(_726 & 255u);
        _746 = (_742 * vec3(0.0039215688593685626983642578125)) * dot(_613.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375));
    }
    else
    {
        _746 = _613.xyz;
    }
    vec3 _797;
    float _798;
    if (FrameConstants.g_fRainfallIntensity > 0.0)
    {
        uint _754 = in_var_TEXCOORD2 + 4u;
        float _777;
        if (g_xInstanceTexture._m0[_754].x >= 0.0)
        {
            _777 = g_xInstanceTexture._m0[_754].x * FrameConstants.g_fRainBaseWetness;
        }
        else
        {
            _777 = SAMPLE_TEXTURE1(SAMPLER_2D(g_xRainReachabilityMask, g_xBilinearClamp), gl_FragCoord.xy / vec2(FrameConstants.g_xScreenDimensions.xy), FrameConstants.g_fGlobalSamplerBias).x;
        }
        float _779 = _777 * (1.0 - g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fPorosity);
        float _780 = _777 * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fPorosity;
        float _789 = mix(1.0, 0.0500000007450580596923828125, _779);
        _797 = mix(_746, clamp(mix(_746, vec3(dot(_746, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375))), vec3(-0.60000002384185791015625)), vec3(0.0), vec3(1.0)) * mix(1.0, 0.4000000059604644775390625, _780), vec3(_780));
        _798 = mix(mix(_611.w, min(_611.w, _789 * _789), _779), _611.w, clamp((in_var_TEXCOORD1.w - 50.0) * 0.00999999977648258209228515625, 0.0, 1.0));
    }
    else
    {
        _797 = _746;
        _798 = _611.w;
    }
    vec4 _813;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
    {
        _813 = vec4(_797, _406);
    }
    else
    {
        _813 = vec4(0.0);
    }
    out_var_SV_Target0 = vec4(1.0, 1.0, 1.0, _406);
    out_var_SV_Target1 = _813;
    out_var_SV_Target2 = vec4((_612 * 0.5) + vec3(0.5), _406 + ((1.0 - _406) * clamp((_406 * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fDecalNormalThresholdA) + g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fDecalNormalThresholdB, 0.0, 1.0)));
    out_var_SV_Target3 = vec4(_722, _798, 0.0, _406);
}

