#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 9, std140) uniform type_HDRBloomAndGodRaysConstants
{
    vec4 g_xRadialBlurCentreAndAspectCorrection;
    vec4 g_xInvAspectAndBrightnessScale;
    vec4 g_xHDRParamsGroup1;
    vec4 g_xHDRParamsGroup2;
    vec4 g_xBloomRTInvSize_ScreenRTInvSize;
} HDRBloomAndGodRaysConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 1, binding = 50) uniform TEXTURE_2D g_xInputTexture;

layout(location = 0) in vec2 in_var_TEXCOORD0;
layout(location = 0) out vec4 out_var_SV_Target;

void main()
{
    vec2 _47 = in_var_TEXCOORD0 * HDRBloomAndGodRaysConstants.g_xRadialBlurCentreAndAspectCorrection.zw;
    //_47.x += vk3d_params[VIEW].stereo.x * 0.5;
    vec2 _49 = HDRBloomAndGodRaysConstants.g_xRadialBlurCentreAndAspectCorrection.xy - _47;
    float _50 = length(_49);
    vec2 _59 = (((_49 / vec2(max(_50, 1.0000000116860974230803549289703e-07))) * vec2(0.083333335816860198974609375)) * 1.10000002384185791015625) * HDRBloomAndGodRaysConstants.g_xInvAspectAndBrightnessScale.xy;
    vec2 _60 = _47 * HDRBloomAndGodRaysConstants.g_xInvAspectAndBrightnessScale.xy;

    float _62 = length(_59 * HDRBloomAndGodRaysConstants.g_xRadialBlurCentreAndAspectCorrection.zw);
    vec4 _64;
    _64 = vec4(0.0);
    vec4 _65;
    for (int _67 = 0; _67 < 12; _64 = _65, _67++)
    {
        float _72 = float(_67);
        float _74 = _62 * _72;
        if (_74 >= _50)
        {
            break;
        }

        vec3 _90 = _64.xyz + (SAMPLE_TEXTURE(SAMPLER_2D(g_xInputTexture, g_xBilinearClamp), clamp(_60 + (_59 * _72), vec2(0.0), vec2(1.0))) * pow(clamp(1.0 - _74, 0.0, 1.0), 8.0)).xyz;
        _65 = vec4(_90.x, _90.y, _90.z, _64.w);
    }
    out_var_SV_Target = _64 * vec4(0.083333335816860198974609375);
}


