// Clouds part 2
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 1, binding = 3, std140) uniform type_SkyboxConstants
{
    layout(row_major) mat4 g_xViewToWorldDir;
    layout(row_major) mat4 g_xStarMatrix;
    vec4 g_xA;
    vec4 g_xB;
    vec4 g_xC;
    vec4 g_xD;
    vec4 g_xE;
    vec4 g_xF;
    vec4 g_xSunDirection;
    vec4 g_xMoonDirection;
    vec4 g_xMoonUAxis;
    vec4 g_xMoonVAxis;
    vec4 g_xFogColour_Sky;
    vec3 g_xSunColour;
    float g_fPad;
    uint g_uNumSkyLayers;
    float g_fHorizonOffset;
    float g_fHorizonScale;
    float g_fVerticalTextureScale;
    vec4 g_axLayerOffset[3];
} SkyboxConstants;

layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 1, binding = 48) uniform TEXTURE_2D g_xSkyLayersTextures0;
layout(set = 1, binding = 49) uniform TEXTURE_2D g_xSkyLayersTextures1;
layout(set = 1, binding = 50) uniform TEXTURE_2D g_xSkyLayersTextures2;

layout(location = 0) in vec3 in_var_Texcoords;
layout(location = 0) out vec4 out_var_SV_TARGET;

void main()
{
    vec3 _68 = in_var_Texcoords / vec3(length(in_var_Texcoords));
    float _80 = (_68.y * SkyboxConstants.g_fHorizonScale) + SkyboxConstants.g_fHorizonOffset;
    vec4 _201;
    if ((_80 < 0.0) && (SkyboxConstants.g_fVerticalTextureScale == 1.0))
    {
        _201 = vec4(0.0);
    }
    else
    {
        vec2 _98 = vec2(atan(-_68.z, -_68.x) * 0.159155070781707763671875, (acos(_80) * SkyboxConstants.g_fVerticalTextureScale) * 0.6366202831268310546875);
       // _98.x += vk3d_params[VIEW].stereo.x ;
        
        vec4 _122;
        if ((2u < SkyboxConstants.g_uNumSkyLayers) && true)
        {
            vec4 _112 = TEXTURE_LOD(SAMPLER_2D(g_xSkyLayersTextures2, g_xFilteredWrap), _98 + vec2(SkyboxConstants.g_axLayerOffset[2].x, 0.0), 0.0);
            float _114 = _112.w;
            vec3 _118 = (_112.xyz * _114) * SkyboxConstants.g_axLayerOffset[2].y;
            vec4 _121 = vec4(_118.x, _118.y, _118.z, vec4(0.0, 0.0, 0.0, 1.0).w);
            _121.w = 1.0 - _114;
            _122 = _121;
        }
        else
        {
            _122 = vec4(0.0, 0.0, 0.0, 1.0);
        }
        vec4 _150;
        if ((1u < SkyboxConstants.g_uNumSkyLayers) && (_122.w >= 0.0039215688593685626983642578125))
        {
            vec4 _136 = TEXTURE_LOD(SAMPLER_2D(g_xSkyLayersTextures1, g_xFilteredWrap), _98 + vec2(SkyboxConstants.g_axLayerOffset[1].x, 0.0), 0.0);
            float _138 = _136.w;
            vec3 _145 = _122.xyz + ((_136.xyz * (_122.w * _138)) * SkyboxConstants.g_axLayerOffset[1].y);
            vec4 _149 = vec4(_145.x, _145.y, _145.z, _122.w);
            _149.w = _122.w * (1.0 - _138);
            _150 = _149;
        }
        else
        {
            _150 = _122;
        }
        vec4 _166;
        if (dot(SkyboxConstants.g_xMoonDirection.xyz, _68) > 0.999700009822845458984375)
        {
            _166 = vec4((vec3(0.5) * _150.w) + _150.xyz, 0.0);
        }
        else
        {
            _166 = _150;
        }
        vec4 _180;
        if (clamp(dot(SkyboxConstants.g_xSunDirection.xyz, _68), 0.0, 1.0) > 0.99940001964569091796875)
        {
            _180 = vec4((SkyboxConstants.g_xSunColour * _166.w) + _166.xyz, 0.0);
        }
        else
        {
            _180 = _166;
        }
        _201 = vec4(((TEXTURE_LOD(SAMPLER_2D(g_xSkyLayersTextures0, g_xFilteredWrap), _98 + vec2(SkyboxConstants.g_axLayerOffset[0].x, 0.0), 0.0).xyz * SkyboxConstants.g_axLayerOffset[0].y) * _180.w) + _180.xyz, _180.w);
    }
    vec3 _209 = mix(_201.xyz, SkyboxConstants.g_xFogColour_Sky.xyz, vec3(SkyboxConstants.g_xFogColour_Sky.w));
    out_var_SV_TARGET = vec4(_209.x, _209.y, _209.z, _201.w);
}


