
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 4, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;
layout(location = 10) in uint in_var_BLENDINDICES2;

void main()
{
    uvec4 _68 = in_var_BLENDINDICES0;
    uvec4 _69 = in_var_BLENDINDICES1;
    vec4 _70 = in_var_BLENDWEIGHTS0;
    vec4 _71 = in_var_BLENDWEIGHTS1;
    uint _91 = in_var_BLENDINDICES2 + (_68.x * 3u);
    mat3x4 _67 = mat3x4(g_xInstanceTexture._m0[_91 + 8u], g_xInstanceTexture._m0[_91 + 9u], g_xInstanceTexture._m0[_91 + 10u]);
    _67[2].z = (_67[0u].x * _67[1u].y) - (_67[0u].y * _67[1u].x);
    mat3x4 _119;
    _119 = _67 * _70.x;
    mat3x4 _120;
    for (int _122 = 1; _122 < 4; _119 = _120, _122++)
    {
        uint _127 = uint(_122);
        if (_70[_127] == 0.0)
        {
            break;
        }
        uint _136 = in_var_BLENDINDICES2 + (_68[_127] * 3u);
        mat3x4 _66 = mat3x4(g_xInstanceTexture._m0[_136 + 8u], g_xInstanceTexture._m0[_136 + 9u], g_xInstanceTexture._m0[_136 + 10u]);
        _66[2].z = (_66[0u].x * _66[1u].y) - (_66[0u].y * _66[1u].x);
        mat3x4 _160 = _66 * _70[_127];
        _120 = mat3x4(_119[0] + _160[0], _119[1] + _160[1], _119[2] + _160[2]);
    }
    mat3x4 _171;
    _171 = _119;
    mat3x4 _172;
    for (int _174 = 0; _174 < 4; _171 = _172, _174++)
    {
        uint _179 = uint(_174);
        if (_71[_179] == 0.0)
        {
            break;
        }
        uint _188 = in_var_BLENDINDICES2 + (_69[_179] * 3u);
        mat3x4 _65 = mat3x4(g_xInstanceTexture._m0[_188 + 8u], g_xInstanceTexture._m0[_188 + 9u], g_xInstanceTexture._m0[_188 + 10u]);
        _65[2].z = (_65[0u].x * _65[1u].y) - (_65[0u].y * _65[1u].x);
        mat3x4 _212 = _65 * _71[_179];
        _172 = mat3x4(_171[0] + _212[0], _171[1] + _212[1], _171[2] + _212[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _171, 1.0) * mat3x4(g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 5u], g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 6u], g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
}

