#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 4, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 1, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 1, binding = 10, std140) uniform type_InstancedConstants
{
    uint g_uInstancedAnimID;
} InstancedConstants;

layout(set = 2, binding = 3, std140) uniform type_DynamicMaterialConstants
{
    vec3 g_xSelfIlluminationParameters;
    float g_fFogScale;
    vec4 g_xUVScaleOffset;
} DynamicMaterialConstants;

layout(set = 3, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;
layout(location = 0) out vec4 out_var_NORMAL0;
layout(location = 1) out vec3 out_var_TANGENT0;
layout(location = 2) out vec3 out_var_BINORMAL0;
layout(location = 3) out vec4 out_var_TEXCOORD0;
layout(location = 4) out vec4 out_var_TEXCOORD1;

void main()
{
    uint _100 = InstancedConstants.g_uInstancedAnimID + 5u;
    uint _103 = InstancedConstants.g_uInstancedAnimID + 6u;
    uint _106 = InstancedConstants.g_uInstancedAnimID + 7u;
    uvec4 _85 = in_var_BLENDINDICES0;
    uvec4 _86 = in_var_BLENDINDICES1;
    vec4 _87 = in_var_BLENDWEIGHTS0;
    vec4 _88 = in_var_BLENDWEIGHTS1;
    uint _113 = InstancedConstants.g_uInstancedAnimID + (_85.x * 3u);
    mat3x4 _84 = mat3x4(g_xInstanceTexture._m0[_113 + 8u], g_xInstanceTexture._m0[_113 + 9u], g_xInstanceTexture._m0[_113 + 10u]);
    float _125 = _84[2].z;
    _84[2].z = (_84[0u].x * _84[1u].y) - (_84[0u].y * _84[1u].x);
    float _144;
    mat3x4 _147;
    _144 = _125 * _87.x;
    _147 = _84 * _87.x;
    float _145;
    mat3x4 _148;
    for (int _149 = 1; _149 < 4; _144 = _145, _147 = _148, _149++)
    {
        uint _154 = uint(_149);
        if (_87[_154] == 0.0)
        {
            break;
        }
        uint _163 = InstancedConstants.g_uInstancedAnimID + (_85[_154] * 3u);
        mat3x4 _83 = mat3x4(g_xInstanceTexture._m0[_163 + 8u], g_xInstanceTexture._m0[_163 + 9u], g_xInstanceTexture._m0[_163 + 10u]);
        float _175 = _83[2].z;
        _83[2].z = (_83[0u].x * _83[1u].y) - (_83[0u].y * _83[1u].x);
        mat3x4 _188 = _83 * _87[_154];
        _148 = mat3x4(_147[0] + _188[0], _147[1] + _188[1], _147[2] + _188[2]);
        _145 = _144 + (_175 * _87[_154]);
    }
    float _200;
    mat3x4 _203;
    _200 = _144;
    _203 = _147;
    float _201;
    mat3x4 _204;
    for (int _205 = 0; _205 < 4; _200 = _201, _203 = _204, _205++)
    {
        uint _210 = uint(_205);
        if (_88[_210] == 0.0)
        {
            break;
        }
        uint _219 = InstancedConstants.g_uInstancedAnimID + (_86[_210] * 3u);
        mat3x4 _82 = mat3x4(g_xInstanceTexture._m0[_219 + 8u], g_xInstanceTexture._m0[_219 + 9u], g_xInstanceTexture._m0[_219 + 10u]);
        float _231 = _82[2].z;
        _82[2].z = (_82[0u].x * _82[1u].y) - (_82[0u].y * _82[1u].x);
        mat3x4 _244 = _82 * _88[_210];
        _204 = mat3x4(_203[0] + _244[0], _203[1] + _244[1], _203[2] + _244[2]);
        _201 = _200 + (_231 * _88[_210]);
    }
    mat3 _281 = mat3(_203[0].xyz, _203[1].xyz, _203[2].xyz);
    vec3 _291 = vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _203, 1.0) * mat3x4(g_xInstanceTexture._m0[_100], g_xInstanceTexture._m0[_103], g_xInstanceTexture._m0[_106]);
    mat3 _295 = mat3(g_xInstanceTexture._m0[_100].xyz, g_xInstanceTexture._m0[_103].xyz, g_xInstanceTexture._m0[_106].xyz);
    vec4 _312 = vec4(_291, 1.0) * FrameConstants.g_xViewProj;
   gl_Position = _312;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y);
    out_var_NORMAL0 = vec4((((in_var_NORMAL * 2.0) - vec3(1.0)) * _281) * _295, in_var_POSITION.w * _200);
    out_var_TANGENT0 = (((in_var_TANGENT * 2.0) - vec3(1.0)) * _281) * _295;
    out_var_BINORMAL0 = (((in_var_BINORMAL * 2.0) - vec3(1.0)) * _281) * _295;
    out_var_TEXCOORD0 = in_var_TEXCOORD + DynamicMaterialConstants.g_xUVScaleOffset;
    out_var_TEXCOORD1 = vec4(FrameConstants.g_xCamPos - _291, _312.w);
}


