// SHADOWS 1
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require
#extension GL_EXT_samplerless_texture_functions : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

const vec2 _97[8] = vec2[](vec2(-0.695039272308349609375, 0.16170980036258697509765625), vec2(-0.24559019505977630615234375, -0.6526126861572265625), vec2(0.24424530565738677978515625, 0.2412090003490447998046875), vec2(-0.84800231456756591796875, -0.3871740996837615966796875), vec2(-0.3136856853961944580078125, 0.60699260234832763671875), vec2(0.4607562124729156494140625, 0.87447822093963623046875), vec2(0.588717520236968994140625, -0.616069495677947998046875), vec2(0.82326567173004150390625, 0.123084597289562225341796875));


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 3, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 1, binding = 10, scalar) uniform type_CSMConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xCSMMapConstants;
} CSMConstants;

layout(set = 0, binding = 8) uniform samplerShadow g_xShadowCmpSampler;
layout(set = 2, binding = 48) uniform TEXTURE_2D g_xNormalBuffer;
layout(set = 2, binding = 49) uniform TEXTURE_2D g_xDepthStencil;
layout(set = 1, binding = 50) uniform texture2D g_xCSM;

layout(location = 0) out vec2 out_var_SV_Target;

void main()
{
    ivec2 _104 = ivec2(floor(gl_FragCoord.xy));
    ivec2 _108 = ivec3(_104, 0).xy;
    float _117 = FrameConstants.g_xDepthProjViewUnpack.x / (FrameConstants.g_xDepthProjViewUnpack.y - TEXEL_FETCH(g_xDepthStencil, _108, 0).x);

    // ORIGINAL FORMULA
    //vec4 _135 = vec4((FrameConstants.g_xCameraTanHalfFOV * _117) * (((vec2(_104) + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _117, 1.0) * FrameConstants.g_xInvView;
    // Grab the whole computation but in ViewSpace
    vec4 _135 = vec4((FrameConstants.g_xCameraTanHalfFOV * _117) * (((vec2(_104) + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _117, 1.0);
    // Do our magic
	_135.x -= vk3d_params[VIEW].stereo.x * (_117 - vk3d_params[VIEW].stereo.y) * FrameConstants.g_xInvProj[0][0];
    // Cast it back to inv View Space
    _135 = _135 * FrameConstants.g_xInvView;

    vec4 _143 = vec4(_135.xyz, 1.0) * CSMConstants.g_xCSMMapConstants.g_xShadowViewProj;
    vec2 _146 = (_143.xy * vec2(0.5, -0.5)) + vec2(0.5);
    float _150 = clamp(_143.z + 1.525902189314365386962890625e-05, 0.0, 1.0);
    vec3 _151 = vec3(_146.x, _146.y, _143.z);
    _151.z = _150;
       
    float _186;
    if (all(greaterThanEqual(_151, vec3(0.0))) && all(lessThan(_151, vec3(1.0))))
    {
        float _162 = 1.5 * CSMConstants.g_xCSMMapConstants.g_fAreaScale;
        float _170;
        _170 = texture(sampler2DShadow(g_xCSM, g_xShadowCmpSampler), vec3(_151.xy, _150));
        for (int _173 = 0; _173 < 8; )
        {
            _170 += textureLod(sampler2DShadow(g_xCSM, g_xShadowCmpSampler), vec3(_151.xy + ((_97[_173] * _162) / vec2(CSMConstants.g_xCSMMapConstants.g_fSize)), _150), 0.0);
            _173++;
            continue;
        }
        _186 = _170 * 0.111111111938953399658203125;
    }
    else
    {
        _186 = 0.0;
    }
    out_var_SV_Target = vec2(trunc((1.0 - clamp(_186 * CSMConstants.g_xCSMMapConstants.g_fStrength, 0.0, 1.0)) * 255.0) + clamp(1.0 - abs(dot(normalize((TEXEL_FETCH(g_xNormalBuffer, _108, 0).xyz * 2.0) - vec3(1.0)), normalize(FrameConstants.g_xCamPos - _135.xyz))), 0.00999999977648258209228515625, 0.9900000095367431640625), _117);
}




