
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 3, binding = 10, std140) uniform type_InstancedConstants
{
    uint g_uInstancedAnimID;
} InstancedConstants;

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 3, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;
layout(location = 0) out vec2 out_var_TEXCOORD0;

void main()
{
    uvec4 _76 = in_var_BLENDINDICES0;
    uvec4 _77 = in_var_BLENDINDICES1;
    vec4 _78 = in_var_BLENDWEIGHTS0;
    vec4 _79 = in_var_BLENDWEIGHTS1;
    uint _101 = InstancedConstants.g_uInstancedAnimID + (_76.x * 3u);
    mat3x4 _75 = mat3x4(g_xInstanceTexture._m0[_101 + 8u], g_xInstanceTexture._m0[_101 + 9u], g_xInstanceTexture._m0[_101 + 10u]);
    _75[2].z = (_75[0u].x * _75[1u].y) - (_75[0u].y * _75[1u].x);
    mat3x4 _129;
    _129 = _75 * _78.x;
    mat3x4 _130;
    for (int _132 = 1; _132 < 4; _129 = _130, _132++)
    {
        uint _137 = uint(_132);
        if (_78[_137] == 0.0)
        {
            break;
        }
        uint _146 = InstancedConstants.g_uInstancedAnimID + (_76[_137] * 3u);
        mat3x4 _74 = mat3x4(g_xInstanceTexture._m0[_146 + 8u], g_xInstanceTexture._m0[_146 + 9u], g_xInstanceTexture._m0[_146 + 10u]);
        _74[2].z = (_74[0u].x * _74[1u].y) - (_74[0u].y * _74[1u].x);
        mat3x4 _170 = _74 * _78[_137];
        _130 = mat3x4(_129[0] + _170[0], _129[1] + _170[1], _129[2] + _170[2]);
    }
    mat3x4 _181;
    _181 = _129;
    mat3x4 _182;
    for (int _184 = 0; _184 < 4; _181 = _182, _184++)
    {
        uint _189 = uint(_184);
        if (_79[_189] == 0.0)
        {
            break;
        }
        uint _198 = InstancedConstants.g_uInstancedAnimID + (_77[_189] * 3u);
        mat3x4 _73 = mat3x4(g_xInstanceTexture._m0[_198 + 8u], g_xInstanceTexture._m0[_198 + 9u], g_xInstanceTexture._m0[_198 + 10u]);
        _73[2].z = (_73[0u].x * _73[1u].y) - (_73[0u].y * _73[1u].x);
        mat3x4 _222 = _73 * _79[_189];
        _182 = mat3x4(_181[0] + _222[0], _181[1] + _222[1], _181[2] + _222[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _181, 1.0) * mat3x4(g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 5u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 6u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
    out_var_TEXCOORD0 = in_var_TEXCOORD.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
}

