// Shadows 4
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 3, binding = 11, std140) uniform type_MeshConstants
{
    vec3 g_xPrecisionOffset;
    uint g_bIsBillboard;
    vec3 g_xPrecisionScale;
    uint g_bIsInteractive;
} MeshConstants;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_TEXCOORD0;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec3 in_var_TESSNORMAL;
layout(location = 4) in vec4 in_var_POSITION1;
layout(location = 5) in vec4 in_var_POSITION2;
layout(location = 6) in vec4 in_var_POSITION3;
layout(location = 7) in vec4 in_var_POSITION4;
layout(location = 0) out vec2 out_var_TEXCOORD0;

vec4 _49;

void main()
{
    vec3 _66 = (in_var_POSITION0.xyz * MeshConstants.g_xPrecisionScale) + MeshConstants.g_xPrecisionOffset;
    vec4 _68 = _49;
    _68.x = dot(_66, in_var_POSITION2.xyz);
    vec4 _70 = _68;
    _70.y = dot(_66, in_var_POSITION3.xyz);
    vec4 _72 = _70;
    _72.z = dot(_66, in_var_POSITION4.xyz);
    vec4 _99;
    if (MeshConstants.g_bIsInteractive != 0u)
    {
        vec4 _81 = _49;
        _81.x = in_var_POSITION2.w;
        vec4 _83 = _81;
        _83.y = in_var_POSITION3.w;
        vec4 _85 = _83;
        _85.z = in_var_POSITION4.w;
        vec3 _91 = cross(_85.xyz, _72.xyz);
        vec3 _97 = (((_91 * sqrt(clamp(1.0 - dot(_85.xyz, _85.xyz), 0.0, 1.0))) + cross(_85.xyz, _91)) * (2.0 * in_var_POSITION0.w)) + _72.xyz;
        _99 = vec4(_97.x, _97.y, _97.z, _72.w);
    }
    else
    {
        _99 = _72;
    }
    gl_Position = vec4(_99.xyz + in_var_POSITION1.xyz, 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;

// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
//gl_Position.x += vk3d_params[VIEW].stereo.x * (gl_Position.w - vk3d_params[VIEW].stereo.y);
    out_var_TEXCOORD0 = in_var_TEXCOORD0.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
//    gl_Position.x = 0;
}



