
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    float g_fBiasFactor;
    float g_fNearClip;
    float g_fFarClip;
};

layout(set = 2, binding = 7, std140) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 3, binding = 12, std140) uniform type_InstanceSingleParams
{
    vec4 g_xInstancePosition;
    vec4 g_xTransform0;
    vec4 g_xTransform1;
    vec4 g_xTransform2;
} InstanceSingleParams;

layout(set = 3, binding = 11, std140) uniform type_MeshConstants
{
    vec3 g_xPrecisionOffset;
    uint g_bIsBillboard;
    vec3 g_xPrecisionScale;
    uint g_bIsInteractive;
} MeshConstants;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_TEXCOORD0;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec3 in_var_TESSNORMAL;

vec4 _42;

void main()
{
    vec3 _60 = (in_var_POSITION0.xyz * MeshConstants.g_xPrecisionScale) + MeshConstants.g_xPrecisionOffset;
    vec4 _62 = _42;
    _62.x = dot(_60, InstanceSingleParams.g_xTransform0.xyz);
    vec4 _64 = _62;
    _64.y = dot(_60, InstanceSingleParams.g_xTransform1.xyz);
    vec4 _66 = _64;
    _66.z = dot(_60, InstanceSingleParams.g_xTransform2.xyz);
    vec4 _93;
    if (MeshConstants.g_bIsInteractive != 0u)
    {
        vec4 _75 = _42;
        _75.x = InstanceSingleParams.g_xTransform0.w;
        vec4 _77 = _75;
        _77.y = InstanceSingleParams.g_xTransform1.w;
        vec4 _79 = _77;
        _79.z = InstanceSingleParams.g_xTransform2.w;
        vec3 _85 = cross(_79.xyz, _66.xyz);
        vec3 _91 = (((_85 * sqrt(clamp(1.0 - dot(_79.xyz, _79.xyz), 0.0, 1.0))) + cross(_79.xyz, _85)) * (2.0 * in_var_POSITION0.w)) + _66.xyz;
        _93 = vec4(_91.x, _91.y, _91.z, _66.w);
    }
    else
    {
        _93 = _66;
    }
    gl_Position = vec4(_93.xyz + InstanceSingleParams.g_xInstancePosition.xyz, 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
}

