// XRAY 1

#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct StaticMaterial
{
    float m_fMaterialIndex;
    vec3 m_xAlbedoTint;
    vec4 m_xParallaxUVScaleAndSpeed;
    float m_fRefractivity;
    float m_fParallaxScale;
    float m_fParallaxBias;
    float m_fAlbedoDetailUVScale;
    float m_fAlbedoDetailValueScale;
    float m_fNormalDetailUVScale;
    float m_fNormalDetailValueScale;
    float m_fMaterialModel;
    float m_fSlopeShaderUVScale;
    float m_fSlopeShaderStrength;
    float m_fSlopeShaderThreshold;
    float m_fSlopeShaderPower;
    float m_fSlopeShaderThresFactor;
    vec3 m_xSlopeShaderNormal;
    vec3 m_xSlopeShaderForward;
    float m_fPad;
    float m_fInvHeightmapBlendSoftness;
    float m_fDecalNormalThresholdA;
    float m_fDecalNormalThresholdB;
    float m_fFoliageCosClippingAngle;
    float m_fWindResponsiveness;
    uint m_bRefractionBlendBackground;
    uint m_bIsDecal;
    uint m_bIsFoliage;
    uint m_bReflectBackfaceNormalsWithView;
    uint m_bUseBinarySearchForParallax;
    uint m_bUseAlbedo;
    uint m_bUseNormalMap;
    uint m_bUseMetalMap;
    uint m_bUseTransparencyMap;
    uint m_bUseSelfIlluminationMap;
    uint m_bUseParallaxMap;
    uint m_bUseEnvironmentMap;
    uint m_bUseAlbedoDetailMap;
    uint m_bUseNormalDetailMap;
    uint m_bUseSelfIlluminationGraph;
    uint m_bUseRefraction;
    uint m_bUseTransparencyGraph;
    uint m_bUseSlopeShader;
    uint m_bUseHairFlowMap;
    uint m_bUseHairNoiseMap;
    uint m_bHasParallaxMap;
    uint m_bUseSlopeShaderAlbedoMap1;
    uint m_bUseSlopeShaderNormalMap1;
    uint m_bUseSlopeShaderTransparencyMap1;
    uint m_bUseDamageThresholdMap;
    uint m_bUseFaceWrinkles;
    uint m_bUseRippleMap;
    uint m_uAlbedoMap;
    uint m_uAlbedoDetailMap;
    uint m_uNormalMap;
    uint m_uNormalDetailMap;
    uint m_uMetalMap;
    uint m_uTransparencyMap;
    uint m_uSelfIlluminationMap;
    uint m_uParallaxMap;
    uint m_uHairFlowMap;
    uint m_uHairNoiseMap;
    uint m_uSlopeShaderAlbedoMap;
    uint m_uSlopeShaderNormalMap;
    uint m_uSlopeShaderTransparencyMap;
    uint m_uDamageThresholdMap;
    uint m_uWrinkleMask_Compressed;
    uint m_uWrinkleMask_Stretched;
    uint m_uWrinkleMap_Compressed;
    uint m_uWrinkleMap_Stretched;
    uint m_uRippleMap;
    uint m_bIsTransmissive;
    uint m_bIsDeformable;
    float m_fDeformableHeight;
    uint m_uDeformableDetailAlbedoMap;
    uint m_uDeformableDetailNormalMap;
    float m_fDeformableDetailMapUVScale;
    float m_fDeformableDetailBlendPower;
    float m_fPorosity;
    uint m_uStructuredBufferIndex;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 4, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 4, binding = 48, scalar) readonly buffer type_StructuredBuffer_StaticMaterial
{
    StaticMaterial _m0[];
} g_axMaterials;

layout(set = 2, binding = 1, scalar) uniform type_Material1Constants
{
    StaticMaterial g_xStaticMaterial1;
} Material1Constants;

layout(set = 2, binding = 3, std140) uniform type_DynamicMaterialConstants
{
    vec3 g_xSelfIlluminationParameters;
    float g_fFogScale;
    vec4 g_xUVScaleOffset;
} DynamicMaterialConstants;

layout(set = 1, binding = 4, std140) uniform type_Asura_XRaySkin_ControlConstants
{
    uint g_bUseExternalRT;
    uint g_bOnlyUseExternalRT;
    uint g_bUseShadow;
} Asura_XRaySkin_ControlConstants;

layout(set = 1, binding = 13, std140) uniform type_Asura_XRaySkin_PrimitiveConstants
{
    vec4 g_xRedSHXRay;
    vec4 g_xGreenSHXRay;
    vec4 g_xBlueSHXRay;
    vec4 g_xDynamicLightDir1;
    vec4 g_xDynamicLightDir2;
    vec4 g_xDynamicLightDir3;
    vec4 g_xDynamicLightColourRGB1;
    vec4 g_xDynamicLightColourRGB2;
    vec4 g_xDynamicLightColourRGB3;
    mat4 g_xDynamicLightShadowMat1;
    uint g_bUseDamageMaps;
} Asura_XRaySkin_PrimitiveConstants;

layout(set = 1, binding = 12, std140) uniform type_CapsulePSConstants
{
    vec3 g_x3DCapsuleEndPos1;
    float g_x3DCapsuleRadius1;
    vec3 g_x3DCapsuleEndPos2;
    float g_x3DCapsuleRadius2;
    vec3 g_xCapsuleProjectionVector;
    float g_fProjectionRadius;
    vec3 g_xCapsuleProjectionUVector;
    float g_fSkinOutlineExtrudeDistance;
    vec3 g_xCapsuleProjectionVVector;
    float g_fPad;
    float g_fCutoutTexture1Influence;
    float g_fCutoutTexture2Influence;
    float g_fProjectionRadiusLerpToCapsuleRadius;
    uint g_uNumNoiseOctaves;
    vec4 g_auNoiseParameters[10];
    float g_fNoiseAlphaStart;
    float g_fNoiseAlphaPeak;
    float g_fNoiseAlphaEnd;
    float g_fInvNoiseFeather;
    vec4 g_xCutOutTextureUVTransform1[3];
    vec4 g_xCutOutTextureUVTransform2[3];
    vec2 g_x2DCapsuleEndPos1;
    vec2 g_x2DCapsuleEndPos2;
    float g_fConeOffset1;
    float g_fSphereRadius1;
    float g_fConeOffset2;
    float g_fSphereRadius2;
    vec2 g_x2DCapsuleVec;
    vec2 g_x2DCapsuleVecNormalised;
    float g_f2DCapsuleVecLength;
    float g_fCosTheta;
    float g_fInvCosTheta;
    float g_fInvTanTheta;
    vec4 g_xFadeParams;
    vec4 g_xCameraTanHalfFOV2;
    vec4 g_xSphereColour;
    uint g_bApplyNoiseToCapsulePass;
    uint g_bApplyNoiseToSkinPass;
    uint g_b3DCapsuleInCapsulePass;
    uint g_b3DCapsuleInSkinPass;
} CapsulePSConstants;

layout(set = 0, binding = 5) uniform sampler g_xTrilinearClamp;
layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 0, binding = 7) uniform sampler g_xFilteredClamp;
layout(set = 0, binding = 8) uniform samplerShadow g_xShadowCmpSampler;
layout(set = 5, binding = 0) 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
uniform texture2D g_xTextureArray[];
layout(set = 2, binding = 88) uniform TEXTURE_2D g_xMaterialsTexture;
layout(set = 2, binding = 51) uniform textureCube g_xEnvironmentMap;
layout(set = 1, binding = 50) uniform texture2D g_xShadowTexture;
layout(set = 1, binding = 86) uniform TEXTURE_2D g_xCutoutTexture1;
layout(set = 1, binding = 87) uniform TEXTURE_2D g_xCutoutTexture2;
layout(set = 1, binding = 99) uniform TEXTURE_2D g_xScreenAlpha;

layout(location = 0) in vec4 in_var_NORMAL0;
layout(location = 1) in vec3 in_var_TANGENT0;
layout(location = 2) in vec3 in_var_BINORMAL0;
layout(location = 3) in vec4 in_var_TEXCOORD0;
layout(location = 4) in vec4 in_var_TEXCOORD1;
layout(location = 0) out vec4 out_var_SV_Target;

float _238;
vec4 _260;
vec3 _261;
vec4 _262;
vec3 _263;

void main()
{
    vec4 _2334;
    do
    {
        vec3 _278 = normalize(in_var_NORMAL0.xyz);
        vec3 _281 = normalize(in_var_TEXCOORD1.xyz);
        float _298;
        do
        {
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseTransparencyMap != 0u)
            {
                _298 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uTransparencyMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
                break;
            }
            else
            {
                _298 = 1.0;
                break;
            }
        } while(false);
        float _306 = FrameConstants.g_xDepthProjViewUnpack.x / (FrameConstants.g_xDepthProjViewUnpack.y - gl_FragCoord.z);
        //vec4 _323 = vec4((FrameConstants.g_xCameraTanHalfFOV * _306) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _306, 1.0) * FrameConstants.g_xInvView;
        vec4 _323 = vec4((FrameConstants.g_xCameraTanHalfFOV * _306) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _306, 1.0);
        _323.x -= vk3d_params[VIEW].stereo.x * (_306 - vk3d_params[VIEW].stereo.y) * FrameConstants.g_xInvProj[0][0];
        _323 = _323 * FrameConstants.g_xInvView; 
       
       // These are the coords
        vec2 _326 = gl_FragCoord.xy * FrameConstants.g_xRcpScreenDims;

        // This is position correction - but the overall cutout is still not right
		if (VIEW == 1)
		{
		  //_326.x -=  vk3d_params[VIEW].stereo.x * ((_306 - vk3d_params[VIEW].stereo.y) *0.5);
		  _326.x -=  vk3d_params[VIEW].stereo.x * ((2 - vk3d_params[VIEW].stereo.y) /2);
		}

        vec3 _331 = vec3((_326 * 2.0) - vec2(1.0), 0.0);
        float _1301;
        if (!(Asura_XRaySkin_ControlConstants.g_bOnlyUseExternalRT != 0u))
        {
            float _909;
            float _910;
            if (CapsulePSConstants.g_b3DCapsuleInSkinPass != 0u)
            {
                vec3 _415 = _323.xyz;
                vec3 _420 = CapsulePSConstants.g_x3DCapsuleEndPos2 - CapsulePSConstants.g_x3DCapsuleEndPos1;
                float _421 = length(_420);
                vec3 _422 = _415 - CapsulePSConstants.g_x3DCapsuleEndPos1;
                vec2 _423 = _331.xy;
                vec2 _429 = vec2(1.0, CapsulePSConstants.g_xCameraTanHalfFOV2.z);
                vec2 _430 = (_423 - CapsulePSConstants.g_x2DCapsuleEndPos1) / _429;
                float _431 = length(_430);
                float _489;
                float _490;
                if (CapsulePSConstants.g_f2DCapsuleVecLength > 9.9999997473787516355514526367188e-05)
                {
                    float _442 = dot(_430, CapsulePSConstants.g_x2DCapsuleVecNormalised);
                    float _487;
                    float _488;
                    if ((_431 < 0.001000000047497451305389404296875) || ((_442 / _431) < CapsulePSConstants.g_fCosTheta))
                    {
                        _487 = CapsulePSConstants.g_fSphereRadius1;
                        _488 = _431;
                    }
                    else
                    {
                        float _456 = length((_423 - CapsulePSConstants.g_x2DCapsuleEndPos2) / _429);
                        float _483;
                        float _484;
                        if ((_456 < 0.001000000047497451305389404296875) || (((_442 - CapsulePSConstants.g_f2DCapsuleVecLength) / _456) > CapsulePSConstants.g_fCosTheta))
                        {
                            _483 = CapsulePSConstants.g_fSphereRadius2;
                            _484 = _456;
                        }
                        else
                        {
                            float _470 = length(_430 - (CapsulePSConstants.g_x2DCapsuleVecNormalised * _442)) * CapsulePSConstants.g_fInvTanTheta;
                            _483 = mix(CapsulePSConstants.g_fSphereRadius1, CapsulePSConstants.g_fSphereRadius2, (_442 - _470) / CapsulePSConstants.g_f2DCapsuleVecLength);
                            _484 = _470 * CapsulePSConstants.g_fInvCosTheta;
                        }
                        _487 = _483;
                        _488 = _484;
                    }
                    _489 = _487;
                    _490 = _488;
                }
                else
                {
                    _489 = CapsulePSConstants.g_fSphereRadius1;
                    _490 = _431;
                }
                float _493 = clamp(1.0 - (_490 / _489), 0.0, 1.0);
                float _907;
                float _908;
                if (_421 > 0.00999999977648258209228515625)
                {
                    float _596 = dot(_422, _420 / vec3(_421));
                    float _905;
                    float _906;
                    if (_596 < 0.0)
                    {
                        float _814 = clamp(1.0 - (length(_422) / CapsulePSConstants.g_x3DCapsuleRadius1), 0.0, 1.0);
                        float _815 = min(_814, _493);
                        bool _818 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                        bool _821 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                        float _904;
                        if (_818 || _821)
                        {
                            float _830 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, CapsulePSConstants.g_x3DCapsuleRadius1, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                            vec3 _835 = _422 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _422));
                            float _839 = dot(_835, CapsulePSConstants.g_xCapsuleProjectionUVector) * _830;
                            float _843 = dot(_835, CapsulePSConstants.g_xCapsuleProjectionVVector) * _830;
                            float _873;
                            if (_818)
                            {
                                _873 = mix(_815, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_839 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_843 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_839 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_843 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _815 * CapsulePSConstants.g_fCutoutTexture1Influence);
                            }
                            else
                            {
                                _873 = _815;
                            }
                            float _903;
                            if (_821)
                            {
                                _903 = mix(_873, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_839 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_843 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_839 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_843 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _873 * CapsulePSConstants.g_fCutoutTexture2Influence);
                            }
                            else
                            {
                                _903 = _873;
                            }
                            _904 = _903;
                        }
                        else
                        {
                            _904 = _815;
                        }
                        _905 = _814;
                        _906 = _904;
                    }
                    else
                    {
                        float _807;
                        float _808;
                        if (_596 > _421)
                        {
                            float _716 = clamp(1.0 - (length(_422) / CapsulePSConstants.g_x3DCapsuleRadius2), 0.0, 1.0);
                            float _717 = min(_716, _493);
                            bool _720 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                            bool _723 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                            float _806;
                            if (_720 || _723)
                            {
                                float _732 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, CapsulePSConstants.g_x3DCapsuleRadius2, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                                vec3 _737 = _422 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _422));
                                float _741 = dot(_737, CapsulePSConstants.g_xCapsuleProjectionUVector) * _732;
                                float _745 = dot(_737, CapsulePSConstants.g_xCapsuleProjectionVVector) * _732;
                                float _775;
                                if (_720)
                                {
                                    _775 = mix(_717, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_741 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_745 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_741 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_745 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _717 * CapsulePSConstants.g_fCutoutTexture1Influence);
                                }
                                else
                                {
                                    _775 = _717;
                                }
                                float _805;
                                if (_723)
                                {
                                    _805 = mix(_775, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_741 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_745 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_741 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_745 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _775 * CapsulePSConstants.g_fCutoutTexture2Influence);
                                }
                                else
                                {
                                    _805 = _775;
                                }
                                _806 = _805;
                            }
                            else
                            {
                                _806 = _717;
                            }
                            _807 = _716;
                            _808 = _806;
                        }
                        else
                        {
                            float _606 = clamp(_596 / _421, 0.0, 1.0);
                            float _611 = mix(CapsulePSConstants.g_x3DCapsuleRadius1, CapsulePSConstants.g_x3DCapsuleRadius2, _606);
                            vec3 _613 = _420 * (_606 * _421);
                            float _618 = clamp(1.0 - (length(_422 - _613) / _611), 0.0, 1.0);
                            float _619 = min(_618, _493);
                            vec3 _621 = _415 - (CapsulePSConstants.g_x3DCapsuleEndPos1 + _613);
                            bool _624 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                            bool _627 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                            float _710;
                            if (_624 || _627)
                            {
                                float _636 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, _611, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                                vec3 _641 = _621 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _621));
                                float _645 = dot(_641, CapsulePSConstants.g_xCapsuleProjectionUVector) * _636;
                                float _649 = dot(_641, CapsulePSConstants.g_xCapsuleProjectionVVector) * _636;
                                float _679;
                                if (_624)
                                {
                                    _679 = mix(_619, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_645 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_649 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_645 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_649 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _619 * CapsulePSConstants.g_fCutoutTexture1Influence);
                                }
                                else
                                {
                                    _679 = _619;
                                }
                                float _709;
                                if (_627)
                                {
                                    _709 = mix(_679, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_645 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_649 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_645 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_649 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _679 * CapsulePSConstants.g_fCutoutTexture2Influence);
                                }
                                else
                                {
                                    _709 = _679;
                                }
                                _710 = _709;
                            }
                            else
                            {
                                _710 = _619;
                            }
                            _807 = _618;
                            _808 = _710;
                        }
                        _905 = _807;
                        _906 = _808;
                    }
                    _907 = _905;
                    _908 = _906;
                }
                else
                {
                    float _503 = clamp(1.0 - (length(_422) / CapsulePSConstants.g_x3DCapsuleRadius1), 0.0, 1.0);
                    float _504 = min(_503, _493);
                    bool _507 = CapsulePSConstants.g_fCutoutTexture1Influence > 0.0;
                    bool _510 = CapsulePSConstants.g_fCutoutTexture2Influence > 0.0;
                    float _593;
                    if (_507 || _510)
                    {
                        float _519 = 1.0 / mix(CapsulePSConstants.g_fProjectionRadius, CapsulePSConstants.g_x3DCapsuleRadius1, CapsulePSConstants.g_fProjectionRadiusLerpToCapsuleRadius);
                        vec3 _524 = _422 - (CapsulePSConstants.g_xCapsuleProjectionVector * dot(CapsulePSConstants.g_xCapsuleProjectionVector, _422));
                        float _528 = dot(_524, CapsulePSConstants.g_xCapsuleProjectionUVector) * _519;
                        float _532 = dot(_524, CapsulePSConstants.g_xCapsuleProjectionVVector) * _519;
                        float _562;
                        if (_507)
                        {
                            _562 = mix(_504, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture1, g_xFilteredWrap), vec2(((_528 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].x) + (_532 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].x, ((_528 * CapsulePSConstants.g_xCutOutTextureUVTransform1[0].y) + (_532 * CapsulePSConstants.g_xCutOutTextureUVTransform1[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform1[2].y)).x, _504 * CapsulePSConstants.g_fCutoutTexture1Influence);
                        }
                        else
                        {
                            _562 = _504;
                        }
                        float _592;
                        if (_510)
                        {
                            _592 = mix(_562, SAMPLE_TEXTURE(SAMPLER_2D(g_xCutoutTexture2, g_xFilteredWrap), vec2(((_528 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].x) + (_532 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].x)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].x, ((_528 * CapsulePSConstants.g_xCutOutTextureUVTransform2[0].y) + (_532 * CapsulePSConstants.g_xCutOutTextureUVTransform2[1].y)) + CapsulePSConstants.g_xCutOutTextureUVTransform2[2].y)).x, _562 * CapsulePSConstants.g_fCutoutTexture2Influence);
                        }
                        else
                        {
                            _592 = _562;
                        }
                        _593 = _592;
                    }
                    else
                    {
                        _593 = _504;
                    }
                    _907 = _503;
                    _908 = _593;
                }
                _909 = _908;
                _910 = _907;
            }
            else
            {
                vec2 _344 = _331.xy;
                vec2 _350 = vec2(1.0, CapsulePSConstants.g_xCameraTanHalfFOV2.z);
                vec2 _351 = (_344 - CapsulePSConstants.g_x2DCapsuleEndPos1) / _350;
                float _352 = length(_351);
                float _410;
                float _411;
                if (CapsulePSConstants.g_f2DCapsuleVecLength > 9.9999997473787516355514526367188e-05)
                {
                    float _363 = dot(_351, CapsulePSConstants.g_x2DCapsuleVecNormalised);
                    float _408;
                    float _409;
                    if ((_352 < 0.001000000047497451305389404296875) || ((_363 / _352) < CapsulePSConstants.g_fCosTheta))
                    {
                        _408 = CapsulePSConstants.g_fSphereRadius1;
                        _409 = _352;
                    }
                    else
                    {
                        float _377 = length((_344 - CapsulePSConstants.g_x2DCapsuleEndPos2) / _350);
                        float _404;
                        float _405;
                        if ((_377 < 0.001000000047497451305389404296875) || (((_363 - CapsulePSConstants.g_f2DCapsuleVecLength) / _377) > CapsulePSConstants.g_fCosTheta))
                        {
                            _404 = CapsulePSConstants.g_fSphereRadius2;
                            _405 = _377;
                        }
                        else
                        {
                            float _391 = length(_351 - (CapsulePSConstants.g_x2DCapsuleVecNormalised * _363)) * CapsulePSConstants.g_fInvTanTheta;
                            _404 = mix(CapsulePSConstants.g_fSphereRadius1, CapsulePSConstants.g_fSphereRadius2, (_363 - _391) / CapsulePSConstants.g_f2DCapsuleVecLength);
                            _405 = _391 * CapsulePSConstants.g_fInvCosTheta;
                        }
                        _408 = _404;
                        _409 = _405;
                    }
                    _410 = _408;
                    _411 = _409;
                }
                else
                {
                    _410 = CapsulePSConstants.g_fSphereRadius1;
                    _411 = _352;
                }
                _909 = clamp(1.0 - (_411 / _410), 0.0, 1.0);
                _910 = _238;
            }
            float _1288;
            if (CapsulePSConstants.g_bApplyNoiseToSkinPass != 0u)
            {
                float _1287;
                do
                {
                    if (CapsulePSConstants.g_uNumNoiseOctaves == 0u)
                    {
                        _1287 = _909;
                        break;
                    }
                    else
                    {
                        float _925;
                        _925 = 0.0;
                        for (uint _928 = 0u; _928 < CapsulePSConstants.g_uNumNoiseOctaves; )
                        {
                            vec4 _941 = vec4(_323.xyz, FrameConstants.g_fScaledTime) * CapsulePSConstants.g_auNoiseParameters[_928].xxxy;
                            vec4 _945 = floor(_941 + vec4(dot(_941, vec4(0.309017002582550048828125))));
                            vec4 _949 = (_941 - _945) + vec4(dot(_945, vec4(0.13819660246372222900390625)));
                            vec3 _952 = step(_949.yzw, _949.xxx);
                            vec3 _955 = step(_949.zww, _949.yyz);
                            vec4 _961 = _262;
                            _961.x = (_952.x + _952.y) + _952.z;
                            vec3 _962 = vec3(1.0) - _952;
                            vec4 _969 = vec4(_961.x, _962.x, _962.y, _962.z);
                            _969.y = _962.x + (_955.x + _955.y);
                            vec2 _973 = _969.zw + (vec2(1.0) - _955.xy);
                            float _975 = _955.z;
                            vec4 _978 = vec4(_969.x, _969.y, _973.x, _973.y);
                            _978.z = _973.x + _975;
                            vec4 _982 = _978;
                            _982.w = _973.y + (1.0 - _975);
                            vec4 _983 = clamp(_982, vec4(0.0), vec4(1.0));
                            vec4 _985 = clamp(_982 - vec4(1.0), vec4(0.0), vec4(1.0));
                            vec4 _987 = clamp(_982 - vec4(2.0), vec4(0.0), vec4(1.0));
                            vec4 _989 = (_949 - _987) + vec4(0.13819660246372222900390625);
                            vec4 _991 = (_949 - _985) + vec4(0.2763932049274444580078125);
                            vec4 _993 = (_949 - _983) + vec4(0.4145897924900054931640625);
                            vec4 _994 = _949 + vec4(-0.447213590145111083984375);
                            vec4 _998 = _945 - (floor(_945 * 0.00346020772121846675872802734375) * 289.0);
                            float _999 = _998.w;
                            float _1002 = ((_999 * _999) * 34.0) + _999;
                            float _1007 = _998.z;
                            float _1008 = (_1002 - (floor(_1002 * 0.00346020772121846675872802734375) * 289.0)) + _1007;
                            float _1011 = ((_1008 * _1008) * 34.0) + _1008;
                            float _1016 = _998.y;
                            float _1017 = (_1011 - (floor(_1011 * 0.00346020772121846675872802734375) * 289.0)) + _1016;
                            float _1020 = ((_1017 * _1017) * 34.0) + _1017;
                            float _1025 = _998.x;
                            float _1026 = (_1020 - (floor(_1020 * 0.00346020772121846675872802734375) * 289.0)) + _1025;
                            float _1029 = ((_1026 * _1026) * 34.0) + _1026;
                            vec4 _1039 = vec4(_999) + vec4(_987.w, _985.w, _983.w, 1.0);
                            vec4 _1042 = ((_1039 * _1039) * 34.0) + _1039;
                            vec4 _1053 = ((_1042 - (floor(_1042 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_1007)) + vec4(_987.z, _985.z, _983.z, 1.0);
                            vec4 _1056 = ((_1053 * _1053) * 34.0) + _1053;
                            vec4 _1067 = ((_1056 - (floor(_1056 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_1016)) + vec4(_987.y, _985.y, _983.y, 1.0);
                            vec4 _1070 = ((_1067 * _1067) * 34.0) + _1067;
                            vec4 _1081 = ((_1070 - (floor(_1070 * 0.00346020772121846675872802734375) * 289.0)) + vec4(_1025)) + vec4(_987.x, _985.x, _983.x, 1.0);
                            vec4 _1084 = ((_1081 * _1081) * 34.0) + _1081;
                            vec4 _1088 = _1084 - (floor(_1084 * 0.00346020772121846675872802734375) * 289.0);
                            vec3 _1094 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * (_1029 - (floor(_1029 * 0.00346020772121846675872802734375) * 289.0))) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                            float _1099 = 1.5 - dot(abs(_1094.xyz), vec3(1.0));
                            vec4 _1100 = vec4(_1094.x, _1094.y, _1094.z, _262.w);
                            _1100.w = _1099;
                            vec3 _1109 = _1100.xyz - vec3(ivec3(sign(_1100.xyz)) * ivec3(int(_1099 < 0.0)));
                            vec4 _1110 = vec4(_1109.x, _1109.y, _1109.z, _1100.w);
                            vec3 _1117 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _1088.x) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                            float _1122 = 1.5 - dot(abs(_1117.xyz), vec3(1.0));
                            vec4 _1123 = vec4(_1117.x, _1117.y, _1117.z, _262.w);
                            _1123.w = _1122;
                            vec3 _1132 = _1123.xyz - vec3(ivec3(sign(_1123.xyz)) * ivec3(int(_1122 < 0.0)));
                            vec4 _1133 = vec4(_1132.x, _1132.y, _1132.z, _1123.w);
                            vec3 _1140 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _1088.y) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                            float _1145 = 1.5 - dot(abs(_1140.xyz), vec3(1.0));
                            vec4 _1146 = vec4(_1140.x, _1140.y, _1140.z, _262.w);
                            _1146.w = _1145;
                            vec3 _1155 = _1146.xyz - vec3(ivec3(sign(_1146.xyz)) * ivec3(int(_1145 < 0.0)));
                            vec4 _1156 = vec4(_1155.x, _1155.y, _1155.z, _1146.w);
                            vec3 _1163 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _1088.z) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                            float _1168 = 1.5 - dot(abs(_1163.xyz), vec3(1.0));
                            vec4 _1169 = vec4(_1163.x, _1163.y, _1163.z, _262.w);
                            _1169.w = _1168;
                            vec3 _1178 = _1169.xyz - vec3(ivec3(sign(_1169.xyz)) * ivec3(int(_1168 < 0.0)));
                            vec4 _1179 = vec4(_1178.x, _1178.y, _1178.z, _1169.w);
                            vec3 _1186 = (floor(fract(vec3(0.003401360474526882171630859375, 0.02040816284716129302978515625, 0.14285714924335479736328125) * _1088.w) * 7.0) * 0.14285714924335479736328125) - vec3(1.0);
                            float _1191 = 1.5 - dot(abs(_1186.xyz), vec3(1.0));
                            vec4 _1192 = vec4(_1186.x, _1186.y, _1186.z, _262.w);
                            _1192.w = _1191;
                            vec3 _1201 = _1192.xyz - vec3(ivec3(sign(_1192.xyz)) * ivec3(int(_1191 < 0.0)));
                            vec4 _1202 = vec4(_1201.x, _1201.y, _1201.z, _1192.w);
                            vec4 _1208 = inversesqrt(vec4(dot(_1110, _1110), dot(_1133, _1133), dot(_1156, _1156), dot(_1179, _1179)));
                            vec3 _1225 = max(vec3(0.60000002384185791015625) - vec3(dot(_949, _949), dot(_989, _989), dot(_991, _991)), vec3(0.0));
                            vec2 _1230 = max(vec2(0.60000002384185791015625) - vec2(dot(_993, _993), dot(_994, _994)), vec2(0.0));
                            vec3 _1231 = _1225 * _1225;
                            vec2 _1232 = _1230 * _1230;
                            _925 += ((49.0 * (dot(_1231 * _1231, vec3(dot(_1110 * _1208.x, _949), dot(_1133 * _1208.y, _989), dot(_1156 * _1208.z, _991))) + dot(_1232 * _1232, vec2(dot(_1179 * _1208.w, _993), dot(_1202 * inversesqrt(dot(_1202, _1202)), _994))))) * CapsulePSConstants.g_auNoiseParameters[_928].z);
                            _928++;
                            continue;
                        }
                        if (_910 <= CapsulePSConstants.g_fNoiseAlphaStart)
                        {
                            _1287 = _909;
                            break;
                        }
                        if (_909 >= CapsulePSConstants.g_fNoiseAlphaEnd)
                        {
                            _1287 = _909;
                            break;
                        }
                        float _1274;
                        if (_909 < CapsulePSConstants.g_fNoiseAlphaPeak)
                        {
                            _1274 = clamp((_909 - CapsulePSConstants.g_fNoiseAlphaStart) / (CapsulePSConstants.g_fNoiseAlphaPeak - CapsulePSConstants.g_fNoiseAlphaStart), 0.0, 1.0);
                        }
                        else
                        {
                            _1274 = clamp(1.0 - ((_909 - CapsulePSConstants.g_fNoiseAlphaPeak) / (CapsulePSConstants.g_fNoiseAlphaEnd - CapsulePSConstants.g_fNoiseAlphaPeak)), 0.0, 1.0);
                        }
                        _1287 = mix(_909, (1.0 - clamp((((min(1.0, max(-1.0, _925)) * 0.5) + 0.5) - _909) * CapsulePSConstants.g_fInvNoiseFeather, 0.0, 1.0)) * _909, _1274);
                        break;
                    }
                } while(false);
                _1288 = _1287;
            }
            else
            {
                _1288 = _909;
            }
            _1301 = 1.0 - pow(1.0 - clamp((_1288 * CapsulePSConstants.g_xFadeParams.x) + CapsulePSConstants.g_xFadeParams.y, 0.0, 1.0), CapsulePSConstants.g_xFadeParams.z);
        }
        else
        {
            _1301 = 1.0;
        }
        float _1316;
        if (Asura_XRaySkin_ControlConstants.g_bUseExternalRT != 0u)
        {
        // Masking for skin capsule
          _1316 = _1301 * clamp((SAMPLE_TEXTURE(SAMPLER_2D(g_xScreenAlpha, g_xFilteredClamp), _326).x * 2.0) - 1.0, 0.0, 1.0);
        }
        else
        {
            _1316 = _1301;
        }
        if ((_1316 - 0.0039215688593685626983642578125) < 0.0)
        {
            discard;
        }
        if (_1316 > 0.0039215688593685626983642578125)
        {
            vec3 _1375;
            do
            {
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
                {
                    vec4 _1338 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
                    vec2 _1341 = (_1338.xy * 2.0) - vec2(1.0);
                    vec3 _1363;
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
                    {
                        vec2 _1361 = _1341.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                        _1363 = vec3(_1361.x, _1361.y, _261.z);
                    }
                    else
                    {
                        _1363 = vec3(_1341.x, _1341.y, _261.z);
                    }
                    vec3 _1366 = _1363;
                    _1366.y = -_1363.y;
                    vec3 _1372 = _1366;
                    _1372.z = sqrt(clamp(1.0 - dot(_1366.xy, _1366.xy), 0.0, 1.0));
                    _1375 = normalize(mat3(normalize(in_var_TANGENT0), normalize(in_var_BINORMAL0), _278) * _1372);
                    break;
                }
                else
                {
                    _1375 = _278;
                    break;
                }
            } while(false);
            vec4 _1385 = vec4(_1375, 1.0);
            vec3 _1387 = _263;
            _1387.x = dot(_1385, Asura_XRaySkin_PrimitiveConstants.g_xRedSHXRay);
            vec3 _1389 = _1387;
            _1389.y = dot(_1385, Asura_XRaySkin_PrimitiveConstants.g_xGreenSHXRay);
            vec3 _1391 = _1389;
            _1391.z = dot(_1385, Asura_XRaySkin_PrimitiveConstants.g_xBlueSHXRay);
            vec3 _1393 = max(_1391, vec3(0.0)) * 2.0;
            vec3 _1402 = normalize(((Asura_XRaySkin_PrimitiveConstants.g_xRedSHXRay.xyz * 0.300000011920928955078125) + (Asura_XRaySkin_PrimitiveConstants.g_xGreenSHXRay.xyz * 0.589999973773956298828125)) + (Asura_XRaySkin_PrimitiveConstants.g_xBlueSHXRay.xyz * 0.10999999940395355224609375));
            vec4 _1456;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
            {
                vec4 _1419 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias);
                vec4 _1448;
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedoDetailMap != 0u)
                {
                    vec3 _1431 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
                    vec3 _1432 = _1419.xyz;
                    vec3 _1446 = clamp(mix(_1432, mix((_1431 * 2.0) * _1432, vec3(1.0) - (((vec3(1.0) - _1431) * 2.0) * (vec3(1.0) - _1432)), step(vec3(0.5), _1432)), vec3(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
                    _1448 = vec4(_1446.x, _1446.y, _1446.z, _1419.w);
                }
                else
                {
                    _1448 = _1419;
                }
                vec3 _1452 = _1448.xyz * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint;
                vec4 _1455 = vec4(_1452.x, _1452.y, _1452.z, _260.w);
                _1455.w = _1448.w;
                _1456 = _1455;
            }
            else
            {
                vec4 _1412 = vec4(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.x, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.y, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.z, _260.w);
                _1412.w = 1.0;
                _1456 = _1412;
            }
            float _1461 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialModel * 0.0039215688593685626983642578125;
            vec4 _1578;
            float _1579;
            if (_1461 == 0.0)
            {
                float _1574;
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                {
                    _1574 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
                }
                else
                {
                    _1574 = 0.0;
                }
                vec3 _1576 = _1393 * (1.0 - _1574);
                _1578 = vec4(_1576.x, _1576.y, _1576.z, _260.w);
                _1579 = _1574;
            }
            else
            {
                vec4 _1559;
                float _1560;
                if (_1461 == 0.0039215688593685626983642578125)
                {
                    float _1544;
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _1544 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
                    }
                    else
                    {
                        _1544 = 1.0;
                    }
                    vec3 _1557 = _1393 + (_1456.xyz * (_1544 * clamp((clamp(dot(_1402, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(_1402, -_281), 0.0, 1.0), 7.0), 0.0, 1.0)));
                    _1559 = vec4(_1557.x, _1557.y, _1557.z, _260.w);
                    _1560 = _1544;
                }
                else
                {
                    vec4 _1529;
                    float _1530;
                    if (_1461 == 0.01960784383118152618408203125)
                    {
                        float _1502;
                        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                        {
                            _1502 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
                        }
                        else
                        {
                            _1502 = 0.5;
                        }
                        float _1506 = (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsTransmissive != 0u) ? 0.5 : 0.0;
                        vec3 _1522 = mix(_1393 * 1.0, _1393 + ((_1456.xyz * clamp((clamp(dot(_1402, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(_1402, -_281), 0.0, 1.0), 7.0), 0.0, 1.0)) * _1506), vec3(_1502));
                        float _1525 = clamp(_1502, 0.0, 1.0) * 0.4980392158031463623046875;
                        _1529 = vec4(_1522.x, _1522.y, _1522.z, _260.w);
                        _1530 = (_1506 > 0.0) ? (_1525 + 0.501960813999176025390625) : _1525;
                    }
                    else
                    {
                        float _1488;
                        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                        {
                            _1488 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
                        }
                        else
                        {
                            _1488 = 0.0;
                        }
                        _1529 = vec4(_1393.x, _1393.y, _1393.z, _260.w);
                        _1530 = _1488;
                    }
                    _1559 = _1529;
                    _1560 = _1530;
                }
                _1578 = _1559;
                _1579 = _1560;
            }
            float _1580 = dot(_1375, _281);
            float _1601;
            do
            {
                if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSelfIlluminationGraph != 0u)
                {
                    _1601 = (TEXTURE_LOD(SAMPLER_2D(g_xMaterialsTexture, g_xTrilinearClamp), vec2((min(1.0, _1580) * 0.498046875) + 0.5, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialIndex), 0.0) * 2.0).y;
                    break;
                }
                else
                {
                    _1601 = 1.0;
                    break;
                }
            } while(false);
            vec3 _1618;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSelfIlluminationMap != 0u)
            {
                _1618 = DynamicMaterialConstants.g_xSelfIlluminationParameters * 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSelfIlluminationMap)], g_xFilteredWrap)), in_var_TEXCOORD0.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _1618 = DynamicMaterialConstants.g_xSelfIlluminationParameters;
            }
            vec3 _1623 = (_1578.xyz + (_1618 * _1601)).xyz * _1456.xyz;
            vec4 _1671;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseEnvironmentMap != 0u)
            {
                vec3 _1640;
                if (_1461 == 0.007843137718737125396728515625)
                {
                    _1640 = vec3(0.0280000008642673492431640625);
                }
                else
                {
                    _1640 = mix(vec3(0.039999999105930328369140625), _1456.xyz, vec3((_1461 != 0.01960784383118152618408203125) ? _1579 : 0.0));
                }
                vec4 _1644 = (vec4(-1.0, -0.0274999998509883880615234375, -0.572000026702880859375, 0.02199999988079071044921875) * (_1456.w * _1456.w)) + vec4(1.0, 0.0425000004470348358154296875, 1.03999996185302734375, -0.039999999105930328369140625);
                float _1645 = _1644.x;
                vec2 _1655 = (vec2(-1.03999996185302734375, 1.03999996185302734375) * ((min(_1645 * _1645, exp2((-9.27999973297119140625) * clamp(_1580, 0.0, 1.0))) * _1645) + _1644.y)) + _1644.zw;
                vec3 _1669 = _1623.xyz + (texture(samplerCube(g_xEnvironmentMap, g_xFilteredClamp), reflect(-_281, _1375) * vec3(1.0, -1.0, 1.0)).xyz * ((_1640 * _1655.x) + vec3(_1655.y)));
                _1671 = vec4(_1669.x, _1669.y, _1669.z, _1578.w);
            }
            else
            {
                _1671 = vec4(_1623.x, _1623.y, _1623.z, _1578.w);
            }
            vec4 _1677 = Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightShadowMat1 * _323;
            vec2 _1687 = (_1677.xy * 0.5) + vec2(0.5);
            vec3 _1691 = vec3(_1687.x, _1687.y, _1677.z);
            _1691.y = 1.0 - _1687.y;
            float _1697 = texture(sampler2DShadow(g_xShadowTexture, g_xShadowCmpSampler), vec3(_1691.xy, _1677.z));
            float _1712 = (_1461 != 0.01960784383118152618408203125) ? _1579 : 0.0;
            vec3 _1714 = normalize(_281 + Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir1.xyz);
            float _1716 = clamp(dot(_1375, Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir1.xyz), 0.0, 1.0);
            float _1717 = clamp(_1580, 0.0, 1.0);
            float _1719 = clamp(dot(_1375, _1714), 0.0, 1.0);
            float _1721 = clamp(dot(_281, _1714), 0.0, 1.0);
            bool _1722 = _1461 == 0.01568627543747425079345703125;
            vec3 _1759;
            vec3 _1760;
            vec3 _1761;
            if (_1722)
            {
                _1759 = vec3(0.046999998390674591064453125);
                _1760 = vec3(_1716);
                _1761 = _1456.xyz;
            }
            else
            {
                vec3 _1755;
                vec3 _1756;
                vec3 _1757;
                if (_1461 == 0.007843137718737125396728515625)
                {
                    _1755 = vec3(0.0280000008642673492431640625);
                    _1756 = vec3(_1716);
                    _1757 = _1456.xyz;
                }
                else
                {
                    vec3 _1751;
                    vec3 _1752;
                    vec3 _1753;
                    if (_1461 == 0.0039215688593685626983642578125)
                    {
                        _1751 = vec3(0.0280000008642673492431640625);
                        _1752 = vec3((clamp((clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir1.xyz, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir1.xyz, -_281), 0.0, 1.0), 7.0), 0.0, 1.0) * _1712) + _1716);
                        _1753 = _1456.xyz;
                    }
                    else
                    {
                        vec3 _1734 = vec3(_1712);
                        _1751 = mix(vec3(0.039999999105930328369140625), _1456.xyz, _1734);
                        _1752 = vec3(_1716);
                        _1753 = mix(_1456.xyz, vec3(0.0), _1734);
                    }
                    _1755 = _1751;
                    _1756 = _1752;
                    _1757 = _1753;
                }
                _1759 = _1755;
                _1760 = _1756;
                _1761 = _1757;
            }
            vec3 _1762 = _1760 * _1761;
            float _1763 = max(_1456.w, 0.0500000007450580596923828125);
            float _1764 = _1763 * _1763;
            vec3 _1861;
            if (_1722)
            {
                float _1799 = clamp(1.0 - _1456.w, 0.0, 1.0);
                float _1801 = ((_1579 * 2.0) - 1.0) * 0.300000011920928955078125;
                float _1807 = pow(_1799, 8.0) * 500.0;
                float _1810 = pow(_1799, 6.0) * 2000.0;
                float _1824 = dot(normalize(_1402 + (_1375 * ((-0.0500000007450580596923828125) + _1801))), _1714);
                float _1844 = dot(normalize(_1402 + (_1375 * ((0.0500000007450580596923828125 + _1801) - (_1799 * 0.0500000007450580596923828125)))), _1714);
                _1861 = _1762 + ((((vec3(((smoothstep(-1.0, 0.0, _1824) * pow(sqrt(clamp(1.0 - (_1824 * _1824), 0.0, 1.0)), 20.0 + _1807)) * ((((_1579 * 0.89999997615814208984375) + 0.100000001490116119384765625) * 0.1500000059604644775390625) * (0.100000001490116119384765625 + _1799))) * ((_1807 + 28.0) * 0.03978873789310455322265625)) * (_1456.xyz / vec3(max(dot(_1456.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375)), 0.001000000047497451305389404296875)))) + vec3(((smoothstep(-1.0, 0.0, _1844) * pow(sqrt(clamp(1.0 - (_1844 * _1844), 0.0, 1.0)), 50.0 + _1810)) * ((((_1579 * 0.5) + 0.5) * 0.014999999664723873138427734375) * _1799)) * ((_1810 + 58.0) * 0.03978873789310455322265625))) * _1716) * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB1.w);
            }
            else
            {
                float _1775 = 2.0 - _1764;
                float _1782 = _1764 * _1764;
                float _1786 = (((_1719 * _1782) - _1719) * _1719) + 1.0;
                _1861 = _1762 + (((((vec3(1.0) - _1759) * exp2((((-5.554729938507080078125) * _1721) - 6.9831600189208984375) * _1721)) + _1759) * ((((1.0 / (((_1717 * _1775) + _1764) * ((_1716 * _1775) + _1764))) * (_1782 * (1.0 / (_1786 * _1786)))) * _1716) * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB1.w)) * 1.0);
            }
            bool _1862 = _1461 == 0.01960784383118152618408203125;
            vec3 _1911;
            if (_1862)
            {
                bool _1865 = _1579 > 0.4980392158031463623046875;
                vec3 _1883 = sqrt(abs(_1761));
                float _1897 = 0.5 / _1764;
                _1911 = mix(_1861, (_1762 + (((((vec3(1.0) - _1883) * exp2((((-5.554729938507080078125) * _1721) - 6.9831600189208984375) * _1721)) + _1883) * ((1.0 / ((4.0 * ((_1716 + _1717) - (_1716 * _1717))) + 9.9999996826552253889678874634872e-21)) * ((1.0 + _1897) * pow(1.0 - (_1719 * _1719), _1897)))) * (_1716 * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB1.w))) + (_1761 * (clamp((clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir1.xyz, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir1.xyz, -_281), 0.0, 1.0), 7.0), 0.0, 1.0) * (_1865 ? 0.5 : 0.0))), vec3((_1865 ? (_1579 - 0.501960813999176025390625) : _1579) * 2.007874011993408203125));
            }
            else
            {
                _1911 = _1861;
            }
            vec3 _1926 = normalize(_281 + Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir2.xyz);
            float _1928 = clamp(dot(_1375, Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir2.xyz), 0.0, 1.0);
            float _1930 = clamp(dot(_1375, _1926), 0.0, 1.0);
            float _1932 = clamp(dot(_281, _1926), 0.0, 1.0);
            vec3 _1969;
            vec3 _1970;
            vec3 _1971;
            if (_1722)
            {
                _1969 = vec3(0.046999998390674591064453125);
                _1970 = vec3(_1928);
                _1971 = _1456.xyz;
            }
            else
            {
                vec3 _1965;
                vec3 _1966;
                vec3 _1967;
                if (_1461 == 0.007843137718737125396728515625)
                {
                    _1965 = vec3(0.0280000008642673492431640625);
                    _1966 = vec3(_1928);
                    _1967 = _1456.xyz;
                }
                else
                {
                    vec3 _1961;
                    vec3 _1962;
                    vec3 _1963;
                    if (_1461 == 0.0039215688593685626983642578125)
                    {
                        _1961 = vec3(0.0280000008642673492431640625);
                        _1962 = vec3((clamp((clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir2.xyz, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir2.xyz, -_281), 0.0, 1.0), 7.0), 0.0, 1.0) * _1712) + _1928);
                        _1963 = _1456.xyz;
                    }
                    else
                    {
                        vec3 _1944 = vec3(_1712);
                        _1961 = mix(vec3(0.039999999105930328369140625), _1456.xyz, _1944);
                        _1962 = vec3(_1928);
                        _1963 = mix(_1456.xyz, vec3(0.0), _1944);
                    }
                    _1965 = _1961;
                    _1966 = _1962;
                    _1967 = _1963;
                }
                _1969 = _1965;
                _1970 = _1966;
                _1971 = _1967;
            }
            vec3 _1972 = _1970 * _1971;
            vec3 _2069;
            if (_1722)
            {
                float _2007 = clamp(1.0 - _1456.w, 0.0, 1.0);
                float _2009 = ((_1579 * 2.0) - 1.0) * 0.300000011920928955078125;
                float _2015 = pow(_2007, 8.0) * 500.0;
                float _2018 = pow(_2007, 6.0) * 2000.0;
                float _2032 = dot(normalize(_1402 + (_1375 * ((-0.0500000007450580596923828125) + _2009))), _1926);
                float _2052 = dot(normalize(_1402 + (_1375 * ((0.0500000007450580596923828125 + _2009) - (_2007 * 0.0500000007450580596923828125)))), _1926);
                _2069 = _1972 + ((((vec3(((smoothstep(-1.0, 0.0, _2032) * pow(sqrt(clamp(1.0 - (_2032 * _2032), 0.0, 1.0)), 20.0 + _2015)) * ((((_1579 * 0.89999997615814208984375) + 0.100000001490116119384765625) * 0.1500000059604644775390625) * (0.100000001490116119384765625 + _2007))) * ((_2015 + 28.0) * 0.03978873789310455322265625)) * (_1456.xyz / vec3(max(dot(_1456.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375)), 0.001000000047497451305389404296875)))) + vec3(((smoothstep(-1.0, 0.0, _2052) * pow(sqrt(clamp(1.0 - (_2052 * _2052), 0.0, 1.0)), 50.0 + _2018)) * ((((_1579 * 0.5) + 0.5) * 0.014999999664723873138427734375) * _2007)) * ((_2018 + 58.0) * 0.03978873789310455322265625))) * _1928) * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB2.w);
            }
            else
            {
                float _1983 = 2.0 - _1764;
                float _1990 = _1764 * _1764;
                float _1994 = (((_1930 * _1990) - _1930) * _1930) + 1.0;
                _2069 = _1972 + (((((vec3(1.0) - _1969) * exp2((((-5.554729938507080078125) * _1932) - 6.9831600189208984375) * _1932)) + _1969) * ((((1.0 / (((_1717 * _1983) + _1764) * ((_1928 * _1983) + _1764))) * (_1990 * (1.0 / (_1994 * _1994)))) * _1928) * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB2.w)) * 1.0);
            }
            vec3 _2118;
            if (_1862)
            {
                bool _2072 = _1579 > 0.4980392158031463623046875;
                vec3 _2090 = sqrt(abs(_1971));
                float _2104 = 0.5 / _1764;
                _2118 = mix(_2069, (_1972 + (((((vec3(1.0) - _2090) * exp2((((-5.554729938507080078125) * _1932) - 6.9831600189208984375) * _1932)) + _2090) * ((1.0 / ((4.0 * ((_1928 + _1717) - (_1928 * _1717))) + 9.9999996826552253889678874634872e-21)) * ((1.0 + _2104) * pow(1.0 - (_1930 * _1930), _2104)))) * (_1928 * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB2.w))) + (_1971 * (clamp((clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir2.xyz, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir2.xyz, -_281), 0.0, 1.0), 7.0), 0.0, 1.0) * (_2072 ? 0.5 : 0.0))), vec3((_2072 ? (_1579 - 0.501960813999176025390625) : _1579) * 2.007874011993408203125));
            }
            else
            {
                _2118 = _2069;
            }
            vec3 _2132 = normalize(_281 + Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir3.xyz);
            float _2134 = clamp(dot(_1375, Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir3.xyz), 0.0, 1.0);
            float _2136 = clamp(dot(_1375, _2132), 0.0, 1.0);
            float _2138 = clamp(dot(_281, _2132), 0.0, 1.0);
            vec3 _2175;
            vec3 _2176;
            vec3 _2177;
            if (_1722)
            {
                _2175 = vec3(0.046999998390674591064453125);
                _2176 = vec3(_2134);
                _2177 = _1456.xyz;
            }
            else
            {
                vec3 _2171;
                vec3 _2172;
                vec3 _2173;
                if (_1461 == 0.007843137718737125396728515625)
                {
                    _2171 = vec3(0.0280000008642673492431640625);
                    _2172 = vec3(_2134);
                    _2173 = _1456.xyz;
                }
                else
                {
                    vec3 _2167;
                    vec3 _2168;
                    vec3 _2169;
                    if (_1461 == 0.0039215688593685626983642578125)
                    {
                        _2167 = vec3(0.0280000008642673492431640625);
                        _2168 = vec3((clamp((clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir3.xyz, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir3.xyz, -_281), 0.0, 1.0), 7.0), 0.0, 1.0) * _1712) + _2134);
                        _2169 = _1456.xyz;
                    }
                    else
                    {
                        vec3 _2150 = vec3(_1712);
                        _2167 = mix(vec3(0.039999999105930328369140625), _1456.xyz, _2150);
                        _2168 = vec3(_2134);
                        _2169 = mix(_1456.xyz, vec3(0.0), _2150);
                    }
                    _2171 = _2167;
                    _2172 = _2168;
                    _2173 = _2169;
                }
                _2175 = _2171;
                _2176 = _2172;
                _2177 = _2173;
            }
            vec3 _2178 = _2176 * _2177;
            vec3 _2275;
            if (_1722)
            {
                float _2213 = clamp(1.0 - _1456.w, 0.0, 1.0);
                float _2215 = ((_1579 * 2.0) - 1.0) * 0.300000011920928955078125;
                float _2221 = pow(_2213, 8.0) * 500.0;
                float _2224 = pow(_2213, 6.0) * 2000.0;
                float _2238 = dot(normalize(_1402 + (_1375 * ((-0.0500000007450580596923828125) + _2215))), _2132);
                float _2258 = dot(normalize(_1402 + (_1375 * ((0.0500000007450580596923828125 + _2215) - (_2213 * 0.0500000007450580596923828125)))), _2132);
                _2275 = _2178 + ((((vec3(((smoothstep(-1.0, 0.0, _2238) * pow(sqrt(clamp(1.0 - (_2238 * _2238), 0.0, 1.0)), 20.0 + _2221)) * ((((_1579 * 0.89999997615814208984375) + 0.100000001490116119384765625) * 0.1500000059604644775390625) * (0.100000001490116119384765625 + _2213))) * ((_2221 + 28.0) * 0.03978873789310455322265625)) * (_1456.xyz / vec3(max(dot(_1456.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375)), 0.001000000047497451305389404296875)))) + vec3(((smoothstep(-1.0, 0.0, _2258) * pow(sqrt(clamp(1.0 - (_2258 * _2258), 0.0, 1.0)), 50.0 + _2224)) * ((((_1579 * 0.5) + 0.5) * 0.014999999664723873138427734375) * _2213)) * ((_2224 + 58.0) * 0.03978873789310455322265625))) * _2134) * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB3.w);
            }
            else
            {
                float _2189 = 2.0 - _1764;
                float _2196 = _1764 * _1764;
                float _2200 = (((_2136 * _2196) - _2136) * _2136) + 1.0;
                _2275 = _2178 + (((((vec3(1.0) - _2175) * exp2((((-5.554729938507080078125) * _2138) - 6.9831600189208984375) * _2138)) + _2175) * ((((1.0 / (((_1717 * _2189) + _1764) * ((_2134 * _2189) + _1764))) * (_2196 * (1.0 / (_2200 * _2200)))) * _2134) * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB3.w)) * 1.0);
            }
            vec3 _2324;
            if (_1862)
            {
                bool _2278 = _1579 > 0.4980392158031463623046875;
                vec3 _2296 = sqrt(abs(_2177));
                float _2310 = 0.5 / _1764;
                _2324 = mix(_2275, (_2178 + (((((vec3(1.0) - _2296) * exp2((((-5.554729938507080078125) * _2138) - 6.9831600189208984375) * _2138)) + _2296) * ((1.0 / ((4.0 * ((_2134 + _1717) - (_2134 * _1717))) + 9.9999996826552253889678874634872e-21)) * ((1.0 + _2310) * pow(1.0 - (_2136 * _2136), _2310)))) * (_2134 * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB3.w))) + (_2177 * (clamp((clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir3.xyz, -_1375), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightDir3.xyz, -_281), 0.0, 1.0), 7.0), 0.0, 1.0) * (_2278 ? 0.5 : 0.0))), vec3((_2278 ? (_1579 - 0.501960813999176025390625) : _1579) * 2.007874011993408203125));
            }
            else
            {
                _2324 = _2275;
            }
            _2334 = vec4(((_1671.xyz + (min(_1911 * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB1.xyz, vec3(1000.0)) * mix(vec3(1.0), vec3((1.0 - _1697) * float(all(lessThanEqual(abs((_1677.xyz * vec3(0.5, 0.5, 1.0)) + vec3(0.0, 0.0, -0.5)), vec3(0.5))))), bvec3(Asura_XRaySkin_ControlConstants.g_bUseShadow != 0u)))).xyz + min(_2118 * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB2.xyz, vec3(1000.0))).xyz + min(_2324 * Asura_XRaySkin_PrimitiveConstants.g_xDynamicLightColourRGB3.xyz, vec3(1000.0)), _298 * _1316);
            break;
        }
        _2334 = vec4(0.0);
        break;
    } while(false);
    out_var_SV_Target = _2334;
}








