
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 4, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;
layout(location = 10) in uint in_var_BLENDINDICES2;
layout(location = 0) out vec2 out_var_TEXCOORD0;

void main()
{
    uvec4 _74 = in_var_BLENDINDICES0;
    uvec4 _75 = in_var_BLENDINDICES1;
    vec4 _76 = in_var_BLENDWEIGHTS0;
    vec4 _77 = in_var_BLENDWEIGHTS1;
    uint _98 = in_var_BLENDINDICES2 + (_74.x * 3u);
    mat3x4 _73 = mat3x4(g_xInstanceTexture._m0[_98 + 8u], g_xInstanceTexture._m0[_98 + 9u], g_xInstanceTexture._m0[_98 + 10u]);
    _73[2].z = (_73[0u].x * _73[1u].y) - (_73[0u].y * _73[1u].x);
    mat3x4 _126;
    _126 = _73 * _76.x;
    mat3x4 _127;
    for (int _129 = 1; _129 < 4; _126 = _127, _129++)
    {
        uint _134 = uint(_129);
        if (_76[_134] == 0.0)
        {
            break;
        }
        uint _143 = in_var_BLENDINDICES2 + (_74[_134] * 3u);
        mat3x4 _72 = mat3x4(g_xInstanceTexture._m0[_143 + 8u], g_xInstanceTexture._m0[_143 + 9u], g_xInstanceTexture._m0[_143 + 10u]);
        _72[2].z = (_72[0u].x * _72[1u].y) - (_72[0u].y * _72[1u].x);
        mat3x4 _167 = _72 * _76[_134];
        _127 = mat3x4(_126[0] + _167[0], _126[1] + _167[1], _126[2] + _167[2]);
    }
    mat3x4 _178;
    _178 = _126;
    mat3x4 _179;
    for (int _181 = 0; _181 < 4; _178 = _179, _181++)
    {
        uint _186 = uint(_181);
        if (_77[_186] == 0.0)
        {
            break;
        }
        uint _195 = in_var_BLENDINDICES2 + (_75[_186] * 3u);
        mat3x4 _71 = mat3x4(g_xInstanceTexture._m0[_195 + 8u], g_xInstanceTexture._m0[_195 + 9u], g_xInstanceTexture._m0[_195 + 10u]);
        _71[2].z = (_71[0u].x * _71[1u].y) - (_71[0u].y * _71[1u].x);
        mat3x4 _219 = _71 * _77[_186];
        _179 = mat3x4(_178[0] + _219[0], _178[1] + _219[1], _178[2] + _219[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _178, 1.0) * mat3x4(g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 5u], g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 6u], g_xInstanceTexture._m0[in_var_BLENDINDICES2 + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
    out_var_TEXCOORD0 = in_var_TEXCOORD.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
}

