
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require
#extension GL_EXT_samplerless_texture_functions : require

struct StaticMaterial
{
    float m_fMaterialIndex;
    vec3 m_xAlbedoTint;
    vec4 m_xParallaxUVScaleAndSpeed;
    float m_fRefractivity;
    float m_fParallaxScale;
    float m_fParallaxBias;
    float m_fAlbedoDetailUVScale;
    float m_fAlbedoDetailValueScale;
    float m_fNormalDetailUVScale;
    float m_fNormalDetailValueScale;
    float m_fMaterialModel;
    float m_fSlopeShaderUVScale;
    float m_fSlopeShaderStrength;
    float m_fSlopeShaderThreshold;
    float m_fSlopeShaderPower;
    float m_fSlopeShaderThresFactor;
    vec3 m_xSlopeShaderNormal;
    vec3 m_xSlopeShaderForward;
    float m_fPad;
    float m_fInvHeightmapBlendSoftness;
    float m_fDecalNormalThresholdA;
    float m_fDecalNormalThresholdB;
    float m_fFoliageCosClippingAngle;
    float m_fWindResponsiveness;
    uint m_bRefractionBlendBackground;
    uint m_bIsDecal;
    uint m_bIsFoliage;
    uint m_bReflectBackfaceNormalsWithView;
    uint m_bUseBinarySearchForParallax;
    uint m_bUseAlbedo;
    uint m_bUseNormalMap;
    uint m_bUseMetalMap;
    uint m_bUseTransparencyMap;
    uint m_bUseSelfIlluminationMap;
    uint m_bUseParallaxMap;
    uint m_bUseEnvironmentMap;
    uint m_bUseAlbedoDetailMap;
    uint m_bUseNormalDetailMap;
    uint m_bUseSelfIlluminationGraph;
    uint m_bUseRefraction;
    uint m_bUseTransparencyGraph;
    uint m_bUseSlopeShader;
    uint m_bUseHairFlowMap;
    uint m_bUseHairNoiseMap;
    uint m_bHasParallaxMap;
    uint m_bUseSlopeShaderAlbedoMap1;
    uint m_bUseSlopeShaderNormalMap1;
    uint m_bUseSlopeShaderTransparencyMap1;
    uint m_bUseDamageThresholdMap;
    uint m_bUseFaceWrinkles;
    uint m_bUseRippleMap;
    uint m_uAlbedoMap;
    uint m_uAlbedoDetailMap;
    uint m_uNormalMap;
    uint m_uNormalDetailMap;
    uint m_uMetalMap;
    uint m_uTransparencyMap;
    uint m_uSelfIlluminationMap;
    uint m_uParallaxMap;
    uint m_uHairFlowMap;
    uint m_uHairNoiseMap;
    uint m_uSlopeShaderAlbedoMap;
    uint m_uSlopeShaderNormalMap;
    uint m_uSlopeShaderTransparencyMap;
    uint m_uDamageThresholdMap;
    uint m_uWrinkleMask_Compressed;
    uint m_uWrinkleMask_Stretched;
    uint m_uWrinkleMap_Compressed;
    uint m_uWrinkleMap_Stretched;
    uint m_uRippleMap;
    uint m_bIsTransmissive;
    uint m_bIsDeformable;
    float m_fDeformableHeight;
    uint m_uDeformableDetailAlbedoMap;
    uint m_uDeformableDetailNormalMap;
    float m_fDeformableDetailMapUVScale;
    float m_fDeformableDetailBlendPower;
    float m_fPorosity;
    uint m_uStructuredBufferIndex;
};

layout(set = 3, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 3, binding = 48, scalar) readonly buffer type_StructuredBuffer_StaticMaterial
{
    StaticMaterial _m0[];
} g_axMaterials;

layout(set = 1, binding = 1, scalar) uniform type_Material1Constants
{
    StaticMaterial g_xStaticMaterial1;
} Material1Constants;

layout(set = 1, binding = 2, scalar) uniform type_Material2Constants
{
    StaticMaterial g_xStaticMaterial2;
} Material2Constants;

layout(set = 1, binding = 3, std140) uniform type_DynamicMaterialConstants
{
    vec3 g_xSelfIlluminationParameters;
    float g_fFogScale;
    vec4 g_xUVScaleOffset;
} DynamicMaterialConstants;

layout(set = 0, binding = 3) uniform sampler g_xBilinearClamp;
layout(set = 0, binding = 5) uniform sampler g_xTrilinearClamp;
layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 4, binding = 0) uniform texture2D g_xTextureArray[];
layout(set = 1, binding = 88) uniform texture2D g_xMaterialsTexture;
layout(set = 2, binding = 78) uniform texture2D g_xIrradianceSampler;
layout(set = 5, binding = 98) uniform texture2D g_xRainReachabilityMask;
layout(set = 5, binding = 101) uniform texture2D g_xDeformationTexture;

layout(location = 0) in vec4 in_var_NORMAL0;
layout(location = 1) in vec3 in_var_TANGENT0;
layout(location = 2) in vec3 in_var_BINORMAL0;
layout(location = 3) in vec4 in_var_TEXCOORD0;
layout(location = 4) in vec4 in_var_TEXCOORD1;
layout(location = 5) in vec4 in_var_TEXCOORD2;
layout(location = 6) in vec4 in_var_TEXCOORD4;
layout(location = 7) in vec2 in_var_TEXCOORD3;
layout(location = 8) in vec3 in_var_TANGENT1;
layout(location = 9) in vec3 in_var_BINORMAL1;
layout(location = 10) in vec3 in_var_TEXCOORD9;
layout(location = 11) in float in_var_TEXCOORD10;
layout(location = 0) out vec4 out_var_SV_Target0;
layout(location = 1) out vec4 out_var_SV_Target1;
layout(location = 2) out vec4 out_var_SV_Target2;
layout(location = 3) out vec4 out_var_SV_Target3;

vec3 _216;
vec4 _217;
vec2 _218;
vec3 _219;

void main()
{
    vec3 _237 = normalize(in_var_TANGENT0);
    vec3 _238 = normalize(in_var_BINORMAL0);
    vec3 _240 = normalize(in_var_NORMAL0.xyz);
    vec3 _242 = normalize(in_var_TANGENT1);
    vec3 _243 = normalize(in_var_BINORMAL1);
    vec3 _246 = normalize(in_var_TEXCOORD1.xyz);
    bool _251 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsDeformable != 0u;
    bool _256 = g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bIsDeformable != 0u;
    vec2 _266 = vec2(FrameConstants.g_fDeformationWindowSize);
    vec2 _267 = (in_var_TEXCOORD9.xz - FrameConstants.g_xDeformationWindowCentre.xz) / _266;
    vec2 _268 = _267 + vec2(0.5);
    float _269 = _268.x;
    float _273 = _268.y;
    float _483;
    float _484;
    vec3 _485;
    float _486;
    vec4 _487;
    if ((((_269 >= 0.0) && (_269 <= 1.0)) && (_273 >= 0.0)) && (_273 <= 1.0))
    {
        float _282 = mix(_256 ? g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fDeformableHeight : 0.0, _251 ? g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fDeformableHeight : 0.0, in_var_TEXCOORD2.w);
        float _478;
        float _479;
        vec3 _480;
        float _481;
        vec4 _482;
        if (_282 > 9.9999997473787516355514526367188e-05)
        {
            vec2 _287 = abs(_267) * 2.0;
            float _290 = max(_287.x, _287.y);
            float _293 = clamp((_290 * _290) * _290, 0.0, 1.0);
            vec3 _304 = -_246;
            float _307 = mix(32.0, 8.0, abs(_246.y));
            float _308 = 1.0 / _307;
            vec2 _311 = (_304.xz * _308) / _266;
            float _315 = 0.5 / _307;
            vec2 _318 = _218;
            _318.x = _315 * dot(_304, _237);
            vec2 _321 = _318;
            _321.y = _315 * dot(_304, _238);
            vec2 _322 = vec2(FrameConstants.g_fDeformationUVDensity * 0.5);
            vec2 _323 = _321 / _322;
            vec2 _326 = _218;
            _326.x = _315 * dot(_304, _242);
            vec2 _329 = _326;
            _329.y = _315 * dot(_304, _243);
            vec2 _330 = _329 / _322;
            float _334 = max(-dot(_304, _240), 0.001000000047497451305389404296875) * _308;
            float _339 = textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _268, 0.0, ivec2(0)).x * _282;
            int _340 = int(_307);
            int _341 = min(200, _340);
            vec3 _346;
            vec2 _348;
            vec2 _350;
            vec2 _352;
            _346 = in_var_TEXCOORD9;
            _348 = _268;
            _350 = in_var_TEXCOORD0.zw;
            _352 = in_var_TEXCOORD0.xy;
            int _344;
            vec3 _347;
            vec2 _349;
            vec2 _351;
            vec2 _353;
            float _355;
            float _357;
            vec3 _368;
            vec2 _369;
            vec2 _370;
            vec2 _371;
            float _372;
            float _373;
            int _343 = 0;
            float _354 = 0.0;
            float _356 = _339;
            for (;;)
            {
                if (_356 > _354)
                {
                    _355 = _354 + _334;
                    _353 = _352 + _323;
                    _351 = _350 + _330;
                    _349 = _348 + _311;
                    _347 = _346 + (_304 * _308);
                    _357 = textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _349, 0.0, ivec2(0)).x * _282;
                    _344 = _343 + 1;
                    if (_344 >= _341)
                    {
                        _368 = _347;
                        _369 = _349;
                        _370 = _351;
                        _371 = _353;
                        _372 = _355;
                        _373 = _357;
                        break;
                    }
                    _343 = _344;
                    _346 = _347;
                    _348 = _349;
                    _350 = _351;
                    _352 = _353;
                    _354 = _355;
                    _356 = _357;
                    continue;
                }
                else
                {
                    _368 = _346;
                    _369 = _348;
                    _370 = _350;
                    _371 = _352;
                    _372 = _354;
                    _373 = _356;
                    break;
                }
            }
            vec3 _375;
            vec2 _378;
            vec2 _380;
            vec2 _382;
            vec2 _392;
            vec2 _394;
            vec2 _396;
            _375 = _368;
            _378 = _369;
            _380 = _370;
            _382 = _371;
            _392 = _311;
            _394 = _330;
            _396 = _323;
            float _384 = _372;
            float _386 = _373;
            float _388 = _308;
            float _390 = _334;
            int _398 = 0;
            for (; _398 < _340; )
            {
                vec2 _397 = _396 * 0.5;
                vec2 _395 = _394 * 0.5;
                vec2 _393 = _392 * 0.5;
                float _391 = _390 * 0.5;
                float _389 = _388 * 0.5;
                float _402 = _386 - _384;
                float _405 = float(int(sign(_402)));
                vec2 _379 = _378 + (_393 * _405);
                _375 += ((_304 * _389) * _405);
                _378 = _379;
                _380 += (_395 * _405);
                _382 += (_397 * _405);
                _384 += (_391 * _405);
                _386 = textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _379, 0.0, ivec2(0)).x * _282;
                _388 = _389;
                _390 = _391;
                _392 = _393;
                _394 = _395;
                _396 = _397;
                _398++;
                continue;
            }
            float _424;
            if (_282 > 0.0)
            {
                _424 = max(0.0, 1.0 - (textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _378, 0.0, ivec2(0)).x * 0.300000011920928955078125));
            }
            else
            {
                _424 = 1.0;
            }
            vec4 _431 = vec4(_375, 1.0) * FrameConstants.g_xViewProj;
            float _448 = 1.0 / float(uvec2(textureSize(g_xDeformationTexture, 0)).x);
            vec2 _471 = (((vec2(textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _378, 0.0, ivec2(0)).x) - vec2(textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _378 + vec2(_448, 0.0), 0.0, ivec2(0)).x, textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _378 + vec2(0.0, _448), 0.0, ivec2(0)).x)) * _282) * FrameConstants.g_fDeformationNormalIntensity) / (vec2(_448) * FrameConstants.g_fDeformationWindowSize);
            vec3 _475 = _219;
            _475.x = -_471.x;
            vec3 _477 = _475;
            _477.y = -_471.y;
            _478 = mix(_431.z / _431.w, gl_FragCoord.z, _293);
            _479 = mix(_424, 1.0, _293);
            _480 = _477;
            _481 = mix(1.0 - smoothstep(0.0, 1.0, pow(textureLodOffset(sampler2D(g_xDeformationTexture, g_xBilinearClamp), _378, 0.0, ivec2(0)).x, mix(_256 ? g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fDeformableDetailBlendPower : 1.0, _251 ? g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fDeformableDetailBlendPower : 1.0, in_var_TEXCOORD2.w))), 1.0, _293);
            _482 = vec4(_382.x, _382.y, _380.x, _380.y);
        }
        else
        {
            _478 = gl_FragCoord.z;
            _479 = 1.0;
            _480 = vec3(0.0, 0.0, 1.0);
            _481 = 1.0;
            _482 = in_var_TEXCOORD0;
        }
        _483 = _478;
        _484 = _479;
        _485 = _480;
        _486 = _481;
        _487 = _482;
    }
    else
    {
        _483 = gl_FragCoord.z;
        _484 = 1.0;
        _485 = vec3(0.0, 0.0, 1.0);
        _486 = 1.0;
        _487 = in_var_TEXCOORD0;
    }
    vec3 _626;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
        {
            vec4 _502 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias);
            vec2 _505 = (_502.xy * 2.0) - vec2(1.0);
            vec3 _527;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
            {
                vec2 _525 = _505.xy + (((texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), _487.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                _527 = vec3(_525.x, _525.y, _216.z);
            }
            else
            {
                _527 = vec3(_505.x, _505.y, _216.z);
            }
            vec3 _545;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsDeformable != 0u)
            {
                vec2 _543 = mix((texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uDeformableDetailNormalMap)], g_xFilteredWrap)), _487.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fDeformableDetailMapUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0), _527.xy, vec2(_486));
                _545 = vec3(_543.x, _543.y, _527.z);
            }
            else
            {
                _545 = _527;
            }
            vec3 _548 = _545;
            _548.y = -_545.y;
            vec3 _554 = _548;
            _554.z = sqrt(clamp(1.0 - dot(_548.xy, _548.xy), 0.0, 1.0));
            vec3 _555 = mat3(_237, _238, _240) * _554;
            vec3 _620;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseNormalMap != 0u)
            {
                vec4 _564 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uNormalMap)], g_xFilteredWrap)), _487.zw, FrameConstants.g_fGlobalSamplerBias);
                vec2 _567 = (_564.xy * 2.0) - vec2(1.0);
                vec3 _589;
                if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseNormalDetailMap != 0u)
                {
                    vec2 _587 = _567.xy + (((texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uNormalDetailMap)], g_xFilteredWrap)), _487.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fNormalDetailValueScale);
                    _589 = vec3(_587.x, _587.y, _216.z);
                }
                else
                {
                    _589 = vec3(_567.x, _567.y, _216.z);
                }
                vec3 _607;
                if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bIsDeformable != 0u)
                {
                    vec2 _605 = mix((texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uDeformableDetailNormalMap)], g_xFilteredWrap)), _487.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fDeformableDetailMapUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0), _589.xy, vec2(_486));
                    _607 = vec3(_605.x, _605.y, _589.z);
                }
                else
                {
                    _607 = _589;
                }
                vec3 _610 = _607;
                _610.y = -_607.y;
                vec3 _616 = _610;
                _616.z = sqrt(clamp(1.0 - dot(_610.xy, _610.xy), 0.0, 1.0));
                _620 = mix(mat3(_242, _243, _240) * _616, _555, vec3(in_var_TEXCOORD2.w));
            }
            else
            {
                _620 = _555;
            }
            vec2 _623 = _620.xz + _485.xy;
            _626 = normalize(vec3(_623.x, _620.y, _623.y));
            break;
        }
        else
        {
            _626 = _240;
            break;
        }
    } while(false);
    float _628 = in_var_TEXCOORD3.x * 0.5;
    vec2 _629 = in_var_TEXCOORD3;
    _629.x = _628;
    vec4 _633 = textureLod(sampler2D(g_xIrradianceSampler, g_xBilinearClamp), _629, 0.0);
    vec2 _635 = _629;
    _635.x = _628 + 0.5;
    vec3 _641 = normalize((textureLod(sampler2D(g_xIrradianceSampler, g_xBilinearClamp), _635, 0.0).xyz * 2.0) - vec3(1.0));
    vec3 _642 = _641.xyz;
    vec3 _646 = (_633.xyz * _633.w) * 2.0;
    vec4 _773;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
    {
        vec4 _663 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias);
        vec4 _676;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsDeformable != 0u)
        {
            _676 = mix(texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uDeformableDetailAlbedoMap)], g_xFilteredWrap)), _487.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fDeformableDetailMapUVScale, FrameConstants.g_fGlobalSamplerBias), _663, vec4(_486));
        }
        else
        {
            _676 = _663;
        }
        vec4 _705;
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseAlbedoDetailMap != 0u)
        {
            vec3 _688 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), _487.xy * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
            vec3 _703 = clamp(mix(_676.xyz, mix((_688 * 2.0) * _676.xyz, vec3(1.0) - (((vec3(1.0) - _688) * 2.0) * (vec3(1.0) - _676.xyz)), step(vec3(0.5), _676.xyz)), vec3(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
            _705 = vec4(_703.x, _703.y, _703.z, _676.w);
        }
        else
        {
            _705 = _676;
        }
        vec3 _709 = _705.xyz * g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint;
        vec4 _710 = vec4(_709.x, _709.y, _709.z, _705.w);
        vec4 _769;
        if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseAlbedo != 0u)
        {
            vec4 _719 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uAlbedoMap)], g_xFilteredWrap)), _487.zw, FrameConstants.g_fGlobalSamplerBias);
            vec4 _732;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bIsDeformable != 0u)
            {
                _732 = mix(texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uDeformableDetailAlbedoMap)], g_xFilteredWrap)), _487.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fDeformableDetailMapUVScale, FrameConstants.g_fGlobalSamplerBias), _719, vec4(_486));
            }
            else
            {
                _732 = _719;
            }
            vec4 _761;
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseAlbedoDetailMap != 0u)
            {
                vec3 _744 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), _487.zw * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
                vec3 _759 = clamp(mix(_732.xyz, mix((_744 * 2.0) * _732.xyz, vec3(1.0) - (((vec3(1.0) - _744) * 2.0) * (vec3(1.0) - _732.xyz)), step(vec3(0.5), _732.xyz)), vec3(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
                _761 = vec4(_759.x, _759.y, _759.z, _732.w);
            }
            else
            {
                _761 = _732;
            }
            vec3 _765 = _761.xyz * g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_xAlbedoTint;
            _769 = mix(vec4(_765.x, _765.y, _765.z, _761.w), _710, vec4(in_var_TEXCOORD2.w));
        }
        else
        {
            _769 = _710;
        }
        vec4 _772 = vec4(_769.x, _769.y, _769.z, _217.w);
        _772.w = _769.w;
        _773 = _772;
    }
    else
    {
        vec4 _656 = vec4(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.x, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.y, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_xAlbedoTint.z, _217.w);
        _656.w = 1.0;
        _773 = _656;
    }
    float _778 = g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialModel * 0.0039215688593685626983642578125;
    vec4 _949;
    float _950;
    if (_778 == 0.0)
    {
        float _945;
        do
        {
            float _929;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _929 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _929 = 0.0;
            }
            if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _945 = mix(texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.zw, FrameConstants.g_fGlobalSamplerBias).w, _929, in_var_TEXCOORD2.w);
                break;
            }
            else
            {
                _945 = _929;
                break;
            }
        } while(false);
        vec3 _947 = _646 * (1.0 - _945);
        _949 = vec4(_947.x, _947.y, _947.z, _217.w);
        _950 = _945;
    }
    else
    {
        vec4 _912;
        float _913;
        if (_778 == 0.0039215688593685626983642578125)
        {
            float _897;
            if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
            {
                _897 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias).w;
            }
            else
            {
                _897 = 1.0;
            }
            vec3 _910 = _646 + (_773.xyz * (_897 * clamp((clamp(dot(_642, -_626), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(_642, -_246), 0.0, 1.0), 7.0), 0.0, 1.0)));
            _912 = vec4(_910.x, _910.y, _910.z, _217.w);
            _913 = _897;
        }
        else
        {
            vec4 _882;
            float _883;
            if (_778 == 0.01960784383118152618408203125)
            {
                float _855;
                do
                {
                    float _839;
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _839 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias).w;
                    }
                    else
                    {
                        _839 = 0.5;
                    }
                    if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _855 = mix(texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.zw, FrameConstants.g_fGlobalSamplerBias).w, _839, in_var_TEXCOORD2.w);
                        break;
                    }
                    else
                    {
                        _855 = _839;
                        break;
                    }
                } while(false);
                float _859 = (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bIsTransmissive != 0u) ? 0.5 : 0.0;
                vec3 _875 = mix(_646 * 1.0, _646 + ((_773.xyz * clamp((clamp(dot(_642, -_626), 0.0, 1.0) * 0.4000000059604644775390625) + pow(clamp(dot(_642, -_246), 0.0, 1.0), 7.0), 0.0, 1.0)) * _859), vec3(_855));
                float _878 = clamp(_855, 0.0, 1.0) * 0.4980392158031463623046875;
                _882 = vec4(_875.x, _875.y, _875.z, _217.w);
                _883 = (_859 > 0.0) ? (_878 + 0.501960813999176025390625) : _878;
            }
            else
            {
                float _823;
                do
                {
                    float _807;
                    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _807 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias).w;
                    }
                    else
                    {
                        _807 = 0.0;
                    }
                    if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseMetalMap != 0u)
                    {
                        _823 = mix(texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uMetalMap)], g_xFilteredWrap)), _487.zw, FrameConstants.g_fGlobalSamplerBias).w, _807, in_var_TEXCOORD2.w);
                        break;
                    }
                    else
                    {
                        _823 = _807;
                        break;
                    }
                } while(false);
                _882 = vec4(_646.x, _646.y, _646.z, _217.w);
                _883 = _823;
            }
            _912 = _882;
            _913 = _883;
        }
        _949 = _912;
        _950 = _913;
    }
    float _972;
    do
    {
        if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSelfIlluminationGraph != 0u)
        {
            _972 = (textureLod(sampler2D(g_xMaterialsTexture, g_xTrilinearClamp), vec2((min(1.0, dot(_626, _246)) * 0.498046875) + 0.5, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fMaterialIndex), 0.0) * 2.0).y;
            break;
        }
        else
        {
            _972 = 1.0;
            break;
        }
    } while(false);
    vec3 _1001;
    if (g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_bUseSelfIlluminationMap != 0u)
    {
        vec4 _986 = texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_uSelfIlluminationMap)], g_xFilteredWrap)), _487.xy, FrameConstants.g_fGlobalSamplerBias);
        float _987 = _986.w;
        float _999;
        if (g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_bUseSelfIlluminationMap != 0u)
        {
            _999 = mix(texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_uSelfIlluminationMap)], g_xFilteredWrap)), _487.zw, FrameConstants.g_fGlobalSamplerBias).w, _987, in_var_TEXCOORD2.w);
        }
        else
        {
            _999 = _987;
        }
        _1001 = DynamicMaterialConstants.g_xSelfIlluminationParameters * _999;
    }
    else
    {
        _1001 = DynamicMaterialConstants.g_xSelfIlluminationParameters;
    }
    vec3 _1004 = _949.xyz + (_1001 * _972);
    float _1009 = clamp(dot(_246, normalize(_246 + _642)), 0.0, 1.0);
    vec4 _1017 = vec4(_1004.x, _1004.y, _1004.z, _949.w);
    _1017.w = (dot(_646, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375)) * 4.0) * (1.0 / ((3.0 * (_1009 * _1009)) + 1.0));
    vec4 _1033 = vec4(_950, _773.w, (_641.xy * 0.5) + vec2(0.5));
    vec4 _1034 = vec4(_773.x, _773.y, _773.z, _217.w);
    _1034.w = _778;
    float _1039 = smoothstep(-0.125, 0.125, dot(_240, -FrameConstants.g_xRainDirection));
    vec4 _1090;
    vec4 _1091;
    if (_1039 > 0.0)
    {
        vec4 _1088;
        vec4 _1089;
        if (FrameConstants.g_fRainfallIntensity > 0.0)
        {
            float _1053 = mix(g_axMaterials._m0[Material2Constants.g_xStaticMaterial2.m_uStructuredBufferIndex].m_fPorosity, g_axMaterials._m0[Material1Constants.g_xStaticMaterial1.m_uStructuredBufferIndex].m_fPorosity, in_var_TEXCOORD2.w);
            float _1065 = _1039 * texture(sampler2D(g_xRainReachabilityMask, g_xBilinearClamp), gl_FragCoord.xy / vec2(FrameConstants.g_xScreenDimensions.xy), FrameConstants.g_fGlobalSamplerBias).x;
            float _1068 = _1065 * (1.0 - _1053);
            float _1069 = _1065 * _1053;
            vec3 _1077 = mix(_1034.xyz, clamp(mix(_1034.xyz, vec3(dot(_1034.xyz, vec3(0.300000011920928955078125, 0.589999973773956298828125, 0.10999999940395355224609375))), vec3(-0.60000002384185791015625)), vec3(0.0), vec3(1.0)) * mix(1.0, 0.4000000059604644775390625, _1069), vec3(_1069));
            float _1078 = mix(1.0, 0.0500000007450580596923828125, _1068);
            vec4 _1087 = _1033;
            _1087.y = mix(mix(_773.w, min(_773.w, _1078 * _1078), _1068), _773.w, clamp((in_var_TEXCOORD1.w - 50.0) * 0.00999999977648258209228515625, 0.0, 1.0));
            _1088 = _1087;
            _1089 = vec4(_1077.x, _1077.y, _1077.z, _1034.w);
        }
        else
        {
            _1088 = _1033;
            _1089 = _1034;
        }
        _1090 = _1088;
        _1091 = _1089;
    }
    else
    {
        _1090 = _1033;
        _1091 = _1034;
    }
    vec3 _1093 = _1091.xyz * _484;
    out_var_SV_Target0 = _1017;
    out_var_SV_Target1 = vec4(_1093.x, _1093.y, _1093.z, _1091.w);
    out_var_SV_Target2 = vec4((_626 * 0.5) + vec3(0.5), (_641.z > 0.0) ? 0.5 : 0.0);
    out_var_SV_Target3 = _1090;
    gl_FragDepth = _483;
}

