
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    uvec3 g_xPad;
};

layout(set = 2, binding = 7, scalar) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 3, binding = 12, std140) uniform type_InstanceSingleParams
{
    vec4 g_xInstancePosition;
    vec4 g_xTransform0;
    vec4 g_xTransform1;
    vec4 g_xTransform2;
} InstanceSingleParams;

layout(set = 3, binding = 11, std140) uniform type_MeshConstants
{
    vec3 g_xPrecisionOffset;
    uint g_bIsBillboard;
    vec3 g_xPrecisionScale;
    uint g_bIsInteractive;
} MeshConstants;

layout(location = 0) in vec4 in_var_POSITION0;
layout(location = 1) in vec4 in_var_TEXCOORD0;
layout(location = 2) in vec3 in_var_NORMAL;
layout(location = 3) in vec3 in_var_TESSNORMAL;
layout(location = 0) out vec2 out_var_TEXCOORD0;

vec4 _49;

void main()
{
    vec3 _68 = (in_var_POSITION0.xyz * MeshConstants.g_xPrecisionScale) + MeshConstants.g_xPrecisionOffset;
    vec4 _70 = _49;
    _70.x = dot(_68, InstanceSingleParams.g_xTransform0.xyz);
    vec4 _72 = _70;
    _72.y = dot(_68, InstanceSingleParams.g_xTransform1.xyz);
    vec4 _74 = _72;
    _74.z = dot(_68, InstanceSingleParams.g_xTransform2.xyz);
    vec4 _101;
    if (MeshConstants.g_bIsInteractive != 0u)
    {
        vec4 _83 = _49;
        _83.x = InstanceSingleParams.g_xTransform0.w;
        vec4 _85 = _83;
        _85.y = InstanceSingleParams.g_xTransform1.w;
        vec4 _87 = _85;
        _87.z = InstanceSingleParams.g_xTransform2.w;
        vec3 _93 = cross(_87.xyz, _74.xyz);
        vec3 _99 = (((_93 * sqrt(clamp(1.0 - dot(_87.xyz, _87.xyz), 0.0, 1.0))) + cross(_87.xyz, _93)) * (2.0 * in_var_POSITION0.w)) + _74.xyz;
        _101 = vec4(_99.x, _99.y, _99.z, _74.w);
    }
    else
    {
        _101 = _74;
    }
    gl_Position = vec4(_101.xyz + InstanceSingleParams.g_xInstancePosition.xyz, 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
    out_var_TEXCOORD0 = in_var_TEXCOORD0.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
}

