// Feet Decals
#version 460
 #extension GL_EXT_multiview : enable
// Vk3DVision SinglePass
///////////////////////////////////////////////////////////////////////////////

#define STEREO 1

#define VIEW gl_ViewIndex

// Stereo and Mono Texture Sampling
#if(STEREO == 1)
	#define SAMPLER_2D sampler2DArray
	#define USAMPLER_2D usampler2DArray
	#define ISAMPLER_2D isampler2DArray
	#define IMAGE_2D image2DArray
	#define UIMAGE_2D uimage2DArray
	#define UTEXTURE_2D utexture2DArray
	#define TEXTURE_2D texture2DArray
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, vec3(uv, VIEW))
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, vec3(uv, VIEW), bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, ivec3(pos, VIEW))
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, ivec3(pos, VIEW), result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, ivec3(uv, VIEW), lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, ivec3(uv, VIEW), lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, vec3(uv, VIEW), lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, vec3(uv, VIEW), lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, vec3(uv, VIEW), comp)
	#define TEXTURE_GATHER1(Sampler, uv) textureGather(Sampler, vec3(uv, VIEW))
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, vec3(uv, VIEW), offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod).xy
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, vec3(P, VIEW), dPdx, dPdy)
#else
	#define SAMPLER_2D sampler2D
	#define USAMPLER_2D usampler2D
	#define ISAMPLER_2D isampler2D
	#define IMAGE_2D image2D
	#define UIMAGE_2D uimage2D
	#define UTEXTURE_2D utexture2D
	#define TEXTURE_2D texture2D
	#define SAMPLE_TEXTURE(Sampler, uv) texture(Sampler, uv)
	#define SAMPLE_TEXTURE1(Sampler, uv, bias) texture(Sampler, uv, bias)
	#define IMAGE_LOAD(Image2D, pos) imageLoad(Image2D, pos)
	#define IMAGE_STORE(Image2D, pos, result) imageStore(Image2D, pos, result)
	#define TEXEL_FETCH(Sampler, uv, lod) texelFetch(Sampler, uv, lod)
	#define TEXEL_FETCH_OFFSET(Sampler, uv, lod, offset) texelFetchOffset(Sampler, uv, lod, offset)
	#define TEXTURE_LOD(Sampler, uv, lod) textureLod(Sampler, uv, lod)
	#define TEXTURE_LOD_OFFSET(Sampler, uv, lod, offset) textureLodOffset(Sampler, uv, lod, offset)
	#define TEXTURE_GATHER(Sampler, uv, comp) textureGather(Sampler, uv, comp)
	#define TEXTURE_GATHER1(Sampler, uv, comp) textureGather(Sampler, uv)
	#define TEXTURE_GATHER_OFFSET(Sampler, uv, offset, comp) textureGatherOffset(Sampler, uv, offset, comp)
	#define TEXTURE_GATHER_OFFSETS(Sampler, uv, offset) textureGatherOffsets(Sampler, uv, offset)
	#define TEXTURE_GATHER_OFFSETS1(Sampler, uv, offset, comp) textureGatherOffsets(Sampler, uv, offset, comp)
	#define TEXTURE_SIZE(Sampler, lod) textureSize(Sampler, lod)
	#define TEXTURE_GRAD(Sampler, P, dPdx, dPdy) textureGrad(Sampler, P, dPdx, dPdy)
#endif 
 ///////////////////////////////////////////////////////////////////////////////
#extension GL_EXT_nonuniform_qualifier : require
#extension GL_EXT_scalar_block_layout : require
#extension GL_EXT_samplerless_texture_functions : require

struct StaticMaterial
{
    float m_fMaterialIndex;
    vec3 m_xAlbedoTint;
    vec4 m_xParallaxUVScaleAndSpeed;
    float m_fRefractivity;
    float m_fParallaxScale;
    float m_fParallaxBias;
    float m_fAlbedoDetailUVScale;
    float m_fAlbedoDetailValueScale;
    float m_fNormalDetailUVScale;
    float m_fNormalDetailValueScale;
    float m_fMaterialModel;
    float m_fSlopeShaderUVScale;
    float m_fSlopeShaderStrength;
    float m_fSlopeShaderThreshold;
    float m_fSlopeShaderPower;
    float m_fSlopeShaderThresFactor;
    vec3 m_xSlopeShaderNormal;
    vec3 m_xSlopeShaderForward;
    float m_fPad;
    float m_fInvHeightmapBlendSoftness;
    float m_fDecalNormalThresholdA;
    float m_fDecalNormalThresholdB;
    float m_fFoliageCosClippingAngle;
    float m_fWindResponsiveness;
    uint m_bRefractionBlendBackground;
    uint m_bIsDecal;
    uint m_bIsFoliage;
    uint m_bReflectBackfaceNormalsWithView;
    uint m_bUseBinarySearchForParallax;
    uint m_bUseAlbedo;
    uint m_bUseNormalMap;
    uint m_bUseMetalMap;
    uint m_bUseTransparencyMap;
    uint m_bUseSelfIlluminationMap;
    uint m_bUseParallaxMap;
    uint m_bUseEnvironmentMap;
    uint m_bUseAlbedoDetailMap;
    uint m_bUseNormalDetailMap;
    uint m_bUseSelfIlluminationGraph;
    uint m_bUseRefraction;
    uint m_bUseTransparencyGraph;
    uint m_bUseSlopeShader;
    uint m_bUseHairFlowMap;
    uint m_bUseHairNoiseMap;
    uint m_bHasParallaxMap;
    uint m_bUseSlopeShaderAlbedoMap1;
    uint m_bUseSlopeShaderNormalMap1;
    uint m_bUseSlopeShaderTransparencyMap1;
    uint m_bUseDamageThresholdMap;
    uint m_bUseFaceWrinkles;
    uint m_bUseRippleMap;
    uint m_uAlbedoMap;
    uint m_uAlbedoDetailMap;
    uint m_uNormalMap;
    uint m_uNormalDetailMap;
    uint m_uMetalMap;
    uint m_uTransparencyMap;
    uint m_uSelfIlluminationMap;
    uint m_uParallaxMap;
    uint m_uHairFlowMap;
    uint m_uHairNoiseMap;
    uint m_uSlopeShaderAlbedoMap;
    uint m_uSlopeShaderNormalMap;
    uint m_uSlopeShaderTransparencyMap;
    uint m_uDamageThresholdMap;
    uint m_uWrinkleMask_Compressed;
    uint m_uWrinkleMask_Stretched;
    uint m_uWrinkleMap_Compressed;
    uint m_uWrinkleMap_Stretched;
    uint m_uRippleMap;
    uint m_bIsTransmissive;
    uint m_bIsDeformable;
    float m_fDeformableHeight;
    uint m_uDeformableDetailAlbedoMap;
    uint m_uDeformableDetailNormalMap;
    float m_fDeformableDetailMapUVScale;
    float m_fDeformableDetailBlendPower;
    float m_fPorosity;
    uint m_uStructuredBufferIndex;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 15, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 2, binding = 0, scalar) uniform type_FrameConstants
{
    layout(row_major) mat4 g_xView;
    layout(row_major) mat4 g_xProj;
    layout(row_major) mat4 g_xViewProj;
    layout(row_major) mat4 g_xInvView;
    layout(row_major) mat4 g_xInvProj;
    layout(row_major) mat4 g_xInvViewProj;
    vec3 g_xCamPos;
    float g_fScaledTime;
    vec4 g_xTwoOverScreenDimensions;
    vec2 g_xCameraTanHalfFOV;
    vec2 g_xCameraFarClipValues;
    vec2 g_xRcpScreenDims;
    vec2 g_xDepthProjViewUnpack;
    vec4 g_axViewFrustumPlanes[6];
    ivec4 g_xScreenDimensions;
    vec4 g_xTessCutoffAndFactors;
    float g_fTessMaxDist;
    float g_fTessRcpRange;
    float g_fDisplacementScale;
    float g_fBackFaceCutoff;
    float g_fFoliageFadeInvDistance;
    float g_fFoliageFadePower;
    uint g_bFoliageFadeEnabled;
    float g_fEnvironmentDecalBias;
    float g_fInstanceDecalBias;
    vec3 g_xWindDirection;
    float g_fWindStrength;
    vec3 g_xSubsurfaceScatteringWeight;
    float g_fGlobalSamplerBias;
    vec3 g_xDeformationWindowCentre;
    float g_fDeformationWindowSize;
    float g_fDeformationUVDensity;
    float g_fDeformationNormalIntensity;
    float g_fRainfallIntensity;
    float g_fRainBaseWetness;
    vec3 g_xRainDirection;
} FrameConstants;

layout(set = 2, binding = 48, scalar) readonly buffer type_StructuredBuffer_StaticMaterial
{
    StaticMaterial _m0[];
} g_axMaterials;

layout(set = 1, binding = 9, std140) uniform type_InstanceDecalParams
{
    vec4 g_xDecalUV;
    vec3 g_xDecalPosition;
    float g_fTextureLodLevel;
    vec3 g_xVertexShaderDecalNormal;
    uint g_uMaterialIndex;
    vec4 g_xVertexShaderDecalUProjection;
    vec4 g_xVertexShaderDecalVProjection;
    vec4 g_xDecalNormal;
    vec4 g_xDecalUProjection;
    vec4 g_xDecalVProjection;
} InstanceDecalParams;

layout(set = 0, binding = 6) uniform sampler g_xFilteredWrap;
layout(set = 3, binding = 0) 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
uniform texture2D g_xTextureArray[];
layout(set = 2, binding = 50) uniform TEXTURE_2D g_xSceneNormal;
layout(set = 2, binding = 51) uniform TEXTURE_2D g_xDepthStencil;

layout(location = 0) out vec4 out_var_SV_Target0;
layout(location = 1) out vec4 out_var_SV_Target1;
layout(location = 2) out vec4 out_var_SV_Target2;
layout(location = 3) out vec4 out_var_SV_Target3;

vec3 _139;
mat3 _140;
vec4 _141;

void main()
{
    ivec2 _149 = ivec3(int(gl_FragCoord.x), int(gl_FragCoord.y), 0).xy;
    float _158 = FrameConstants.g_xDepthProjViewUnpack.x / (FrameConstants.g_xDepthProjViewUnpack.y - TEXEL_FETCH(g_xDepthStencil, _149, 0).x);
    //vec3 _179 = (vec4((FrameConstants.g_xCameraTanHalfFOV * _158) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _158, 1.0) * FrameConstants.g_xInvView).xyz;

 	vec4 temp = vec4((FrameConstants.g_xCameraTanHalfFOV * _158) * (((gl_FragCoord.xy + FrameConstants.g_xTwoOverScreenDimensions.zw) * FrameConstants.g_xTwoOverScreenDimensions.xy) - vec2(1.0)), _158, 1.0);
    
	temp.x -= vk3d_params[VIEW].stereo.x * (_158 - vk3d_params[VIEW].stereo.y) * FrameConstants.g_xInvProj[0][0];	
	vec3 _179 = (temp * FrameConstants.g_xInvView).xyz;
	
	
	
    vec3 _181 = dFdx(_179);
    vec3 _182 = dFdy(_179);
    float _183 = _158 * 0.02999999932944774627685546875;
    vec3 _199 = normalize((TEXEL_FETCH(g_xSceneNormal, _149, 0).xyz * 2.0) - vec3(1.0));
    vec3 _202 = _179 - InstanceDecalParams.g_xDecalPosition;
    float _206 = dot(_202, InstanceDecalParams.g_xDecalNormal.xyz);
    vec3 _208 = _202 - (_199 * _206);
    vec3 _213 = _139;
    _213.x = dot(_208, InstanceDecalParams.g_xDecalUProjection.xyz);
    vec3 _218 = _213;
    _218.y = dot(_208, InstanceDecalParams.g_xDecalVProjection.xyz);
    vec3 _222 = _218;
    _222.z = _206 * InstanceDecalParams.g_xDecalVProjection.w;
    if (any(lessThan(vec3(1.0) - abs(_222), vec3(0.0))))
    {
        discard;
    }
    vec2 _235 = (_222.xy * InstanceDecalParams.g_xDecalUV.xy) + InstanceDecalParams.g_xDecalUV.zw;
    mat3 _242 = _140;
    _242[0] = normalize(InstanceDecalParams.g_xDecalUProjection.xyz) * ((InstanceDecalParams.g_xDecalUV.x < 0.0) ? (-1.0) : 1.0);
    mat3 _249 = _242;
    _249[1] = normalize(InstanceDecalParams.g_xDecalVProjection.xyz) * ((InstanceDecalParams.g_xDecalUV.y < 0.0) ? (-1.0) : 1.0);
    mat3 _250 = _249;
    _250[2] = InstanceDecalParams.g_xDecalNormal.xyz;
    vec2 _404;
    if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseParallaxMap != 0u)
    {
        vec4 _258 = _235.xyxy;
        vec3 _259 = (FrameConstants.g_xCamPos - _179) * _250;
        vec4 _402;
        if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseParallaxMap != 0u)
        {
            vec4 _401;
            if ((g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseParallaxMap != 0u) && (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseBinarySearchForParallax != 0u))
            {
                vec3 _346 = normalize((-_259) / vec3(_259.z));
                _346.z = 1.0;
                vec3 _348;
                vec4 _353;
                _348 = _346;
                _353 = _258;
                vec3 _349;
                float _352;
                vec4 _354;
                float _351 = 0.0;
                int _355 = 0;
                for (; _355 < 12; _348 = _349, _351 = _352, _353 = _354, _355++)
                {
                    float _388;
                    if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseParallaxMap != 0u)
                    {
                        _388 = ((1.0 - 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uParallaxMap)], g_xFilteredWrap)), (_353.xy * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x) * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fParallaxScale) + g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fParallaxBias;
                    }
                    else
                    {
                        _388 = 0.0;
                    }
                    _349 = _348 * 0.5;
                    if (_351 < _388)
                    {
                        _352 = _351 + _349.z;
                        _354 = _353 + _349.xyxy;
                    }
                    else
                    {
                        _352 = _351 - _349.z;
                        _354 = _353 - _349.xyxy;
                    }
                }
                _401 = _353;
            }
            else
            {
                float _300;
                if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseParallaxMap != 0u)
                {
                    _300 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uParallaxMap)], g_xFilteredWrap)), (_235.xy * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fParallaxScale) + g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fParallaxBias;
                }
                else
                {
                    _300 = 0.0;
                }
                vec2 _302 = _259.xy * _300;
                float _332;
                if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseParallaxMap != 0u)
                {
                    _332 = (
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uParallaxMap)], g_xFilteredWrap)), ((_258 + _302.xyxy).xy * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xParallaxUVScaleAndSpeed.xy) + (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xParallaxUVScaleAndSpeed.zw * FrameConstants.g_fScaledTime), FrameConstants.g_fGlobalSamplerBias).x * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fParallaxScale) + g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fParallaxBias;
                }
                else
                {
                    _332 = 0.0;
                }
                _401 = _258 + (_302 * clamp((-_300) / (_332 - (2.0 * _300)), 0.0, 1.0)).xyxy;
            }
            _402 = _401;
        }
        else
        {
            _402 = _258;
        }
        _404 = _402.xy;
    }
    else
    {
        _404 = _235;
    }
    vec4 _610;
    float _611;
    vec3 _612;
    if ((max(abs(dot(_181, _181)), abs(dot(_182, _182))) > (_183 * _183)) ? true : false)
    {
        float _559;
        do
        {
            if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseTransparencyMap != 0u)
            {
                float _554 = textureLod(nonuniformEXT(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uTransparencyMap)], g_xFilteredWrap)), _404, InstanceDecalParams.g_fTextureLodLevel).w * InstanceDecalParams.g_xDecalNormal.w;
                if ((_554 - 0.0500000007450580596923828125) < 0.0)
                {
                    discard;
                }
                _559 = _554;
                break;
            }
            else
            {
                _559 = 1.0;
                break;
            }
        } while(false);
        vec4 _581;
        if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseAlbedo != 0u)
        {
            vec4 _573 = textureLod(nonuniformEXT(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uAlbedoMap)], g_xFilteredWrap)), _404, InstanceDecalParams.g_fTextureLodLevel);
            vec3 _577 = _573.xyz * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint;
            vec4 _580 = vec4(_577.x, _577.y, _577.z, _141.w);
            _580.w = _573.w;
            _581 = _580;
        }
        else
        {
            vec4 _569 = vec4(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint.x, g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint.y, g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint.z, _141.w);
            _569.w = 1.0;
            _581 = _569;
        }
        vec3 _609;
        do
        {
            if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseNormalMap != 0u)
            {
                vec2 _596 = (textureLod(nonuniformEXT(
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uNormalMap)], g_xFilteredWrap)), _404, InstanceDecalParams.g_fTextureLodLevel).xy * 2.0) - vec2(1.0);
                vec3 _600 = vec3(_596.x, _596.y, _139.z);
                _600.y = -_596.y;
                vec3 _606 = _600;
                _606.z = sqrt(clamp(1.0 - dot(_600.xy, _600.xy), 0.0, 1.0));
                _609 = normalize(_250 * _606);
                break;
            }
            else
            {
                _609 = InstanceDecalParams.g_xDecalNormal.xyz;
                break;
            }
        } while(false);
        _610 = _581;
        _611 = _559;
        _612 = _609;
    }
    else
    {
        float _433;
        do
        {
            if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseTransparencyMap != 0u)
            {
                vec4 _426 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uTransparencyMap)], g_xFilteredWrap)), _404.xy, (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fMaterialModel == 4.0) ? (-1.0) : 0.0);
                float _428 = _426.w * InstanceDecalParams.g_xDecalNormal.w;
                if ((_428 - 0.0500000007450580596923828125) < 0.0)
                {
                    discard;
                }
                _433 = _428;
                break;
            }
            else
            {
                _433 = 1.0;
                break;
            }
        } while(false);
        vec4 _487;
        if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseAlbedo != 0u)
        {
            vec4 _450 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uAlbedoMap)], g_xFilteredWrap)), _404.xy, FrameConstants.g_fGlobalSamplerBias);
            vec4 _479;
            if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseAlbedoDetailMap != 0u)
            {
                vec3 _462 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uAlbedoDetailMap)], g_xFilteredWrap)), _404.xy * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fAlbedoDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xyz;
                vec3 _463 = _450.xyz;
                vec3 _477 = clamp(mix(_463, mix((_462 * 2.0) * _463, vec3(1.0) - (((vec3(1.0) - _462) * 2.0) * (vec3(1.0) - _463)), step(vec3(0.5), _463)), vec3(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fAlbedoDetailValueScale)), vec3(0.0), vec3(1.0));
                _479 = vec4(_477.x, _477.y, _477.z, _450.w);
            }
            else
            {
                _479 = _450;
            }
            vec3 _483 = _479.xyz * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint;
            vec4 _486 = vec4(_483.x, _483.y, _483.z, _141.w);
            _486.w = _479.w;
            _487 = _486;
        }
        else
        {
            vec4 _443 = vec4(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint.x, g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint.y, g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_xAlbedoTint.z, _141.w);
            _443.w = 1.0;
            _487 = _443;
        }
        vec3 _538;
        do
        {
            if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseNormalMap != 0u)
            {
                vec4 _501 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uNormalMap)], g_xFilteredWrap)), _404, FrameConstants.g_fGlobalSamplerBias);
                vec2 _504 = (_501.xy * 2.0) - vec2(1.0);
                vec3 _526;
                if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseNormalDetailMap != 0u)
                {
                    vec2 _524 = _504.xy + (((
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uNormalDetailMap)], g_xFilteredWrap)), _404 * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fNormalDetailUVScale, FrameConstants.g_fGlobalSamplerBias).xy * 2.0) - vec2(1.0)) * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fNormalDetailValueScale);
                    _526 = vec3(_524.x, _524.y, _139.z);
                }
                else
                {
                    _526 = vec3(_504.x, _504.y, _139.z);
                }
                vec3 _529 = _526;
                _529.y = -_526.y;
                vec3 _535 = _529;
                _535.z = sqrt(clamp(1.0 - dot(_529.xy, _529.xy), 0.0, 1.0));
                _538 = normalize(_250 * _535);
                break;
            }
            else
            {
                _538 = InstanceDecalParams.g_xDecalNormal.xyz;
                break;
            }
        } while(false);
        _610 = _487;
        _611 = _433;
        _612 = _538;
    }
    float _635;
    if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseMetalMap != 0u)
    {
        _635 = 
// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
texture(nonuniformEXT(sampler2D(g_xTextureArray[nonuniformEXT(g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_uMetalMap)], g_xFilteredWrap)), _404.xy, FrameConstants.g_fGlobalSamplerBias).w;
    }
    else
    {
        _635 = 0.0;
    }
    float _636 = _611 * clamp(dot(_199, InstanceDecalParams.g_xDecalNormal.xyz) + 0.5, 0.0, 1.0);
    vec4 _652;
    if (g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_bUseAlbedo != 0u)
    {
        _652 = vec4(_610.xyz, _636);
    }
    else
    {
        _652 = vec4(0.0);
    }
    out_var_SV_Target0 = vec4(1.0, 1.0, 1.0, _636);
    out_var_SV_Target1 = _652;
    out_var_SV_Target2 = vec4((mix(_199, _612, vec3(clamp(dot(_199, _612) * 2.0, 0.0, 1.0))) * 0.5) + vec3(0.5), _636 + ((1.0 - _636) * clamp((_636 * g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fDecalNormalThresholdA) + g_axMaterials._m0[InstanceDecalParams.g_uMaterialIndex].m_fDecalNormalThresholdB, 0.0, 1.0)));
    out_var_SV_Target3 = vec4(_635, _610.w, 0.0, _636);
}


