
// Vk3DVision (http://3dsurroundgaming.com/) - Original Shader
#version 460
 #extension GL_EXT_multiview : enable
#extension GL_EXT_nonuniform_qualifier : require

struct CSMSingleMapConstantsStruct
{
    mat4 g_xShadowViewProj;
    mat4 g_xInvShadowByViewProj;
    mat4 g_xScaledInvShadowByViewProj;
    float g_fSize;
    float g_fAreaScale;
    float g_fBlendArea;
    float g_fStrength;
    uint g_uMap;
    float g_fBiasFactor;
    float g_fNearClip;
    float g_fFarClip;
};

layout(set = 3, binding = 9, std140) uniform type_UnpackConstants
{
    vec4 g_xScalingFactors;
    vec4 g_xOffsets;
} UnpackConstants;

layout(set = 3, binding = 10, std140) uniform type_InstancedConstants
{
    uint g_uInstancedAnimID;
} InstancedConstants;

layout(set = 2, binding = 7, std140) uniform type_ShadowConstants
{
    layout(row_major) CSMSingleMapConstantsStruct g_xShadowConstants;
} ShadowConstants;

layout(set = 1, binding = 8, std140) uniform type_AnimUVConstsShadow
{
    vec4 g_xUV_Offsets_Shadow;
} AnimUVConstsShadow;

layout(set = 3, binding = 80, std430) readonly buffer type_StructuredBuffer_v4float
{
    vec4 _m0[];
} g_xInstanceTexture;

layout(location = 0) in vec4 in_var_POSITION;
layout(location = 1) in vec3 in_var_TANGENT;
layout(location = 2) in vec3 in_var_BINORMAL;
layout(location = 3) in vec3 in_var_NORMAL;
layout(location = 4) in vec3 in_var_TESSNORMAL;
layout(location = 5) in vec4 in_var_TEXCOORD;
layout(location = 6) in vec4 in_var_BLENDWEIGHTS0;
layout(location = 7) in vec4 in_var_BLENDWEIGHTS1;
layout(location = 8) in uvec4 in_var_BLENDINDICES0;
layout(location = 9) in uvec4 in_var_BLENDINDICES1;
layout(location = 0) out vec2 out_var_TEXCOORD0;

void main()
{
    uvec4 _75 = in_var_BLENDINDICES0;
    uvec4 _76 = in_var_BLENDINDICES1;
    vec4 _77 = in_var_BLENDWEIGHTS0;
    vec4 _78 = in_var_BLENDWEIGHTS1;
    uint _100 = InstancedConstants.g_uInstancedAnimID + (_75.x * 3u);
    mat3x4 _74 = mat3x4(g_xInstanceTexture._m0[_100 + 8u], g_xInstanceTexture._m0[_100 + 9u], g_xInstanceTexture._m0[_100 + 10u]);
    _74[2].z = (_74[0u].x * _74[1u].y) - (_74[0u].y * _74[1u].x);
    mat3x4 _128;
    _128 = _74 * _77.x;
    mat3x4 _129;
    for (int _131 = 1; _131 < 4; _128 = _129, _131++)
    {
        uint _136 = uint(_131);
        if (_77[_136] == 0.0)
        {
            break;
        }
        uint _145 = InstancedConstants.g_uInstancedAnimID + (_75[_136] * 3u);
        mat3x4 _73 = mat3x4(g_xInstanceTexture._m0[_145 + 8u], g_xInstanceTexture._m0[_145 + 9u], g_xInstanceTexture._m0[_145 + 10u]);
        _73[2].z = (_73[0u].x * _73[1u].y) - (_73[0u].y * _73[1u].x);
        mat3x4 _169 = _73 * _77[_136];
        _129 = mat3x4(_128[0] + _169[0], _128[1] + _169[1], _128[2] + _169[2]);
    }
    mat3x4 _180;
    _180 = _128;
    mat3x4 _181;
    for (int _183 = 0; _183 < 4; _180 = _181, _183++)
    {
        uint _188 = uint(_183);
        if (_78[_188] == 0.0)
        {
            break;
        }
        uint _197 = InstancedConstants.g_uInstancedAnimID + (_76[_188] * 3u);
        mat3x4 _72 = mat3x4(g_xInstanceTexture._m0[_197 + 8u], g_xInstanceTexture._m0[_197 + 9u], g_xInstanceTexture._m0[_197 + 10u]);
        _72[2].z = (_72[0u].x * _72[1u].y) - (_72[0u].y * _72[1u].x);
        mat3x4 _221 = _72 * _78[_188];
        _181 = mat3x4(_180[0] + _221[0], _180[1] + _221[1], _180[2] + _221[2]);
    }
    gl_Position = vec4(vec4(vec4((in_var_POSITION.xyz * UnpackConstants.g_xScalingFactors.xyz) + UnpackConstants.g_xOffsets.xyz, 1.0) * _180, 1.0) * mat3x4(g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 5u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 6u], g_xInstanceTexture._m0[InstancedConstants.g_uInstancedAnimID + 7u]), 1.0) * ShadowConstants.g_xShadowConstants.g_xShadowViewProj;
    out_var_TEXCOORD0 = in_var_TEXCOORD.xy + AnimUVConstsShadow.g_xUV_Offsets_Shadow.xy;
}

